/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*-----------------------------------------------------------------------------



  File: _locdwb.p



  Description: Locates Actuate Developer Workbench on a system.



  Input Parameters:

      <none>



  Output Parameters:

      locdwb (char) - locates DWB and returns its full pathname. If it is

                      not installed, locdwb = ?



  Author: Gerry Seidl



  Modified on 

     05/04/99 by gfs - Created

 *---------------------------------------------------------------------------*/

DEFINE OUTPUT PARAMETER locdwb AS CHARACTER INITIAL ? NO-UNDO.



/* If it's installed, it's location is in the Registry */

LOAD "Software\Actuate\Actuate Developer Workbench":U BASE-KEY "HKEY_LOCAL_MACHINE":U NO-ERROR.

IF NOT ERROR-STATUS:ERROR THEN DO:

  USE "Software\Actuate\Actuate Developer Workbench":U.

  GET-KEY-VALUE SECTION "File Path":U KEY DEFAULT VALUE locdwb.

  USE "".

  /* If there is something in the registry, make sure it's really there */

  IF locdwb <> ? THEN DO:

    ASSIGN FILE-INFO:FILE-NAME = locdwb.

    IF FILE-INFO:FULL-PATHNAME <> ? THEN 

      ASSIGN locdwb = FILE-INFO:FULL-PATHNAME. /* It's installed */

    ELSE 

      ASSIGN locdwb = ?. /* Not found */

  END.

END.

RETURN. 

