/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/



/*----------------------------------------------------------------------------



File: qidxrpt.p



Description:

   Quick and dirty area report for both the GUI and character dictionary.



Input Parameters:

   p_DbId    - Id of the _Db record corresponding to the current database

   p_PName   - Physical name of the database

   p_DbType  - Database type (e.g., PROGRESS)



 

Author: Donna McMann



Date Created: 1/5/98

     History:  09/22/99 Corrected help preprocessor variable



----------------------------------------------------------------------------*/



{adecomm/commeng.i}  /* Help contexts */



DEFINE INPUT PARAMETER p_DbId 	 AS RECID NO-UNDO.

DEFINE VAR header_str AS CHAR 	 NO-UNDO.





header_str =  " Storage Areas and extent information ".



RUN adecomm/_report.p 

   (INPUT p_DbId, 

    INPUT header_str,

    INPUT "Quick Storage Area Report",

    INPUT "",

    INPUT "",

    INPUT "adecomm/_qaredat.p",

    INPUT "",

    INPUT {&QUICK_STORAGE_AREA_REPORT}).





RETURN RETURN-VALUE.

