&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME wWin

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS wWin 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: _coderefs.w



  Description: from cntnrwin.w - ADM SmartWindow Template

  AppBuilder's Code References Window.



  Input Parameters:

      <none>



  Output Parameters:

      <none>



  Author: J. Palazzo (jep)

  Created: May, 1999



  History: New V9 Version - January 15, 1998

          

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AB.              */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



{adecomm/adestds.i}        /* Standared ADE Preprocessor Directives */

IF NOT initialized_adestds THEN RUN adecomm/_adeload.p.

{adeuib/sharvars.i}

{adeuib/uniwidg.i}

{adeuib/uibhlp.i}



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartWindow

&Scoped-define DB-AWARE no



&Scoped-define ADM-CONTAINER WINDOW



&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME fMain



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define the widget handle for the window                              */

DEFINE VAR wWin AS WIDGET-HANDLE NO-UNDO.



/* Definitions of handles for SmartObjects                              */

DEFINE VARIABLE h_coderef-objnames AS HANDLE NO-UNDO.

DEFINE VARIABLE h_coderef-preproc AS HANDLE NO-UNDO.

DEFINE VARIABLE h_folder AS HANDLE NO-UNDO.



/* ************************  Frame Definitions  *********************** */



DEFINE FRAME fMain

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1

         SIZE 78.2 BY 22.1.





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartWindow

   Allow: Basic,Browse,DB-Fields,Query,Smart,Window

   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

   Design Page: 1

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

IF SESSION:DISPLAY-TYPE = "GUI":U THEN

  CREATE WINDOW wWin ASSIGN

         HIDDEN             = YES

         TITLE              = "Code References"

         HEIGHT             = 22.1

         WIDTH              = 78.2

         MAX-HEIGHT         = 28.81

         MAX-WIDTH          = 146.2

         VIRTUAL-HEIGHT     = 28.81

         VIRTUAL-WIDTH      = 146.2

         SHOW-IN-TASKBAR    = no

         MAX-BUTTON         = no

         RESIZE             = no

         SCROLL-BARS        = no

         STATUS-AREA        = no

         BGCOLOR            = ?

         FGCOLOR            = ?

         THREE-D            = yes

         MESSAGE-AREA       = no

         SENSITIVE          = yes.

ELSE {&WINDOW-NAME} = CURRENT-WINDOW.



&IF '{&WINDOW-SYSTEM}' NE 'TTY' &THEN

IF NOT wWin:LOAD-ICON("adeicon/uib%":U) THEN

    MESSAGE "Unable to load icon: adeicon/uib%"

            VIEW-AS ALERT-BOX WARNING BUTTONS OK.

&ENDIF

/* END WINDOW DEFINITION                                                */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB wWin 

/* ************************* Included-Libraries *********************** */



{src/adm2/containr.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW wWin

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME fMain

                                                                        */

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)

THEN wWin:HIDDEN = yes.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 







/* ************************  Control Triggers  ************************ */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin

ON ALT-O OF wWin /* Objects */

ANYWHERE DO:

  RUN displayTab("Objects":U).

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin

ON ALT-P OF wWin /* Preprocessor */

ANYWHERE DO:

  RUN displayTab("Preprocessor":U).

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&Scoped-define SELF-NAME wWin

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin

ON END-ERROR OF wWin /* Code References */

OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:

  /* This case occurs when the user presses the "Esc" key.

     In a persistently run window, just ignore this.  If we did not, the

     application would exit. */

  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin

ON WINDOW-CLOSE OF wWin /* Code References */

DO:

  /* This ADM code must be left here in order for the SmartWindow

     and its descendents to terminate properly on exit. */

  /* APPLY "CLOSE":U TO THIS-PROCEDURE. */

  ASSIGN {&WINDOW-NAME}:VISIBLE = NO.

  RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK wWin 





/* ***************************  Main Block  *************************** */



SUBSCRIBE "SE_EXIT":U   ANYWHERE RUN-PROCEDURE "exitObject":U.

SUBSCRIBE "SE_CLOSE":U  ANYWHERE RUN-PROCEDURE "hideObject":U.



/* Include custom  Main Block code for SmartWindows. */

{src/adm2/windowmn.i}



/* Indicate this persistent procedure is an ADE tool. */

{adecomm/_adetool.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wWin  _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/

  DEFINE VARIABLE currentPage  AS INTEGER NO-UNDO.



  ASSIGN currentPage = getCurrentPage().



  CASE currentPage: 



    WHEN 0 THEN DO:

       RUN constructObject (

             INPUT  'adm2/folder.w':U ,

             INPUT  FRAME fMain:HANDLE ,

             INPUT  'FolderLabels':U + '&Objects|&Preprocessor' + 'FolderTabType1HideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_folder ).

       RUN repositionObject IN h_folder ( 1.48 , 1.00 ) NO-ERROR.

       RUN resizeObject IN h_folder ( 21.43 , 78.00 ) NO-ERROR.



       /* Links to SmartFolder h_folder. */

       RUN addLink ( h_folder , 'Page':U , THIS-PROCEDURE ).



    END. /* Page 0 */



    WHEN 1 THEN DO:

       RUN constructObject (

             INPUT  'adeuib/_coderef-objnames.w':U ,

             INPUT  FRAME fMain:HANDLE ,

             INPUT  'HideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_coderef-objnames ).

       RUN repositionObject IN h_coderef-objnames ( 3.38 , 3.00 ) NO-ERROR.

       /* Size in AB:  ( 19.00 , 73.60 ) */



    END. /* Page 1 */



    WHEN 2 THEN DO:

       RUN constructObject (

             INPUT  'adeuib/_coderef-preproc.w':U ,

             INPUT  FRAME fMain:HANDLE ,

             INPUT  'HideOnInitnoDisableOnInitnoObjectLayout':U ,

             OUTPUT h_coderef-preproc ).

       RUN repositionObject IN h_coderef-preproc ( 3.38 , 3.00 ) NO-ERROR.

       /* Size in AB:  ( 19.00 , 73.60 ) */



       /* Adjust the tab order of the smart objects. */

    END. /* Page 2 */



  END CASE.

  /* Select a Startup page. */

  IF currentPage eq 0

  THEN RUN selectPage IN THIS-PROCEDURE ( 1 ).



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI wWin  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Delete the WINDOW we created */

  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)

  THEN DELETE WIDGET wWin.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE displayTab wWin 

PROCEDURE displayTab :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE INPUT PARAMETER pcTab AS CHARACTER NO-UNDO.

  

  CASE pcTab:

    WHEN "Objects":U THEN

    DO:

        RUN selectPage ( INPUT 1 ).

        /* Put focus in the insert window. Fixes 19990603-009 (jep). */ 

        RUN ApplyEntryCodeRef IN h_coderef-objnames.

    END.



    WHEN "Preprocessor":U THEN

    DO:

        RUN selectPage ( INPUT 2 ).

        /* Put focus in the insert window. Fixes 19990603-009 (jep). */ 

        RUN ApplyEntryCodeRef IN h_coderef-preproc.

    END.

  END CASE.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI wWin  _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  VIEW FRAME fMain IN WINDOW wWin.

  {&OPEN-BROWSERS-IN-QUERY-fMain}

  VIEW wWin.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE exitObject wWin 

PROCEDURE exitObject :

/*------------------------------------------------------------------------------

  Purpose:  Window-specific override of this procedure which destroys 

            its contents and itself.

    Notes:  

------------------------------------------------------------------------------*/



  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE hideObject wWin 

PROCEDURE hideObject :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */



  IF _multiple_section_ed THEN

    RUN SUPER.

  ELSE

    RUN exitObject.

    

  /* Code placed here will execute AFTER standard behavior.    */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject wWin 

PROCEDURE initializeObject :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */



  /* Keep this window from becoming the parent window to other dialog boxes

     by pointing current window to the AB main window. Fixes 19990910-019 (jep) */

  ASSIGN CURRENT-WINDOW = _h_menu_win.



  /* Parent the Code References window to AB main so when AB main is minimized,

     this window minimizes. (jep) */

  ASSIGN

    {&WINDOW-NAME}:PARENT         = _h_menu_win

    {&WINDOW-NAME}:PRIVATE-DATA   = "{&UIB_SHORT_NAME}":u.



  /* If Webspeed Workshop-only, then change image from AB to Workshop. */

  IF _AB_License = 2 THEN

    {&WINDOW-NAME}:LOAD-ICON("adeicon/workshp%":U) NO-ERROR.



  /* jep-icf: Override titlebar icon for ICF. */

  IF CAN-DO(_AB_Tools,"Enable-ICF") THEN

    {&WINDOW-NAME}:LOAD-ICON("adeicon/icfdev.ico":U) NO-ERROR.



  RUN initPages("1,2":U).



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE restoreWindow wWin 

PROCEDURE restoreWindow :

/*------------------------------------------------------------------------------

  Purpose:     Restores Window to normal state.

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  {&WINDOW-NAME}:VISIBLE = YES.

  IF {&WINDOW-NAME}:WINDOW-STATE = WINDOW-MINIMIZED THEN

    {&WINDOW-NAME}:WINDOW-STATE = WINDOW-NORMAL.

  

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



