&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&Scoped-define FRAME-NAME gDialog

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: Select DataSource



  Description: dialog boc that calls the persitent procedure to 

               update dataSource. (Also called from _wizds.w)  



  Input Parameters:

      <none>



  Output Parameters:

      <none>



   Author:  Haavard Danielsen

  Created: 13/7/98 

  

     Note: This procedure MUST NOT CREATE a widget-pool because a _U widget

           may be created  for the query

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/********* 



DON'T CREATE WIDGET-POOL.

BECAUSE THIS PROCEDURE MAY CREATE A QUERY WHICH NEEDS A WIDGET 



********/





/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



&GLOBAL-DEFINE WIN95-BTN YES



{adeuib/uibhlp.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDialog

&Scoped-define DB-AWARE no



&Scoped-define ADM-CONTAINER DIALOG-BOX



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME gDialog



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define a dialog box                                                  */



/* ************************  Frame Definitions  *********************** */



DEFINE FRAME gDialog

     SPACE(55.06) SKIP(10.21)

    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 

         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 

         TITLE "Select DataSource".





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDialog

   Allow: Basic,Browse,DB-Fields,Query,Smart

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS







/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR DIALOG-BOX gDialog

                                                                        */

ASSIGN 

       FRAME gDialog:SCROLLABLE       = FALSE

       FRAME gDialog:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 







/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME gDialog

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog

ON WINDOW-CLOSE OF FRAME gDialog /* Select DataSource */

DO:  

  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */

  APPLY "END-ERROR":U TO SELF.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 





/* ***************************  Main Block  *************************** */





def var hdl as handle.



RUN adeuib/_datasrc.w PERSISTENT SET hdl.



DYNAMIC-FUNCTION('setParent' in HDL, FRAMe {&FRAME-NAME}:HANDLE).

DYNAMIC-FUNCTION('setHTMLMapping' in HDL, TRUE).

DYNAMIC-FUNCTION('setIsFirst'    in HDL,TRUE).



RUN initializeObject in hdl.



ON GO OF FRAME {&FRAME-NAME} DO:

  RUN SaveData in hdl (true) no-error.

  IF ERROR-STATUS:ERROR THEN 

    RETURN NO-APPLY. 

END. 



 

{adecomm/okbar.i &TOOL    = "AB"

                 &CONTEXT = {&Help_on_DataSource} }



VIEW FRAME {&FRAME-NAME}.

DO TRANSACTION ON ENDKEY UNDO,LEAVE ON ERROR  UNDO,LEAVE:

  

  WAIT-FOR "GO" OF FRAME {&FRAME-NAME}.

END.



RUN destroyObject in hdl.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME gDialog.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  VIEW FRAME gDialog.

  {&OPEN-BROWSERS-IN-QUERY-gDialog}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



