&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v7r11 GUI

/* Procedure Description

"Basic Dialog-Box Template



Use this template to create a new dialog-box. Alter this default template or create new ones to accomodate your needs for different default sizes and/or attributes."

*/

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&Scoped-define FRAME-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: _mulcont.w

  

      Pick a single thing from a list of things



  Description: 



  Input Parameters:

      title        - char. Add the string as the title

      itemList     - char, chr(10) sep. The list of items to choose from

      defaultItem  - char. The default item to hilite. If ? or empty then

                     the first item is default.

 



  Output Parameters:

      chosenItem   - char. The chosen item

      cancelled    - logical. 



  Author: D. Lee



  Created: APR-20-1995

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* ***************************  Definitions  ************************** */



{adeuib/uibhlp.i}



/* Parameters Definitions ---                                           */



define input  parameter titleLine   as character no-undo.

define input  parameter itemList    as character no-undo.

define input  parameter defaultItem as character no-undo.

define output parameter chosenItem  as character no-undo initial ?.

define output parameter cancelled   as logical   no-undo initial true.



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE DIALOG-BOX



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME Dialog-Frame



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS Btn_Cancel Btn_Help e theList 

&Scoped-Define DISPLAYED-OBJECTS theList 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define a dialog box                                                  */

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 

     LABEL "Cancel" 

     SIZE 12 BY 1.08

     BGCOLOR 8 .



DEFINE BUTTON Btn_Help 

     LABEL "&Help" 

     SIZE 12 BY 1.08

     BGCOLOR 8 .



DEFINE BUTTON e AUTO-GO 

     LABEL "OK" 

     SIZE 12 BY 1.08

     BGCOLOR 8 .



DEFINE VARIABLE theList AS CHARACTER 

     VIEW-AS SELECTION-LIST SINGLE SCROLLBAR-VERTICAL 

     SIZE 30 BY 4.5 NO-UNDO.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME Dialog-Frame

     theList AT ROW 1.5 COL 2 NO-LABEL

     e AT ROW 1.5 COL 33

     Btn_Cancel AT ROW 2.81 COL 33

     Btn_Help AT ROW 4.77 COL 33

     SPACE(1.13) SKIP(0.52)

    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 

         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 

         TITLE "Choose One"

         CANCEL-BUTTON Btn_Cancel.



 



/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: DIALOG-BOX

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS





/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

ASSIGN 

       FRAME Dialog-Frame:SCROLLABLE       = FALSE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 









/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame

ON GO OF FRAME Dialog-Frame /* Choose Control From */

DO:

    run adecomm/_setcurs.p("WAIT").

    

    assign

        cancelled = no

        chosenItem = theList

    .  

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame

ON WINDOW-CLOSE OF FRAME Dialog-Frame /* Choose Control From */

DO:



    APPLY "END-ERROR":U TO SELF.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_Help

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Help Dialog-Frame

ON CHOOSE OF Btn_Help IN FRAME Dialog-Frame /* Help */

OR HELP OF FRAME {&FRAME-NAME}

DO: /* Call Help Function (or a simple message). */

  run adecomm/_adehelp.p("AB", "CONTEXT", {&Other_VBX_binary_Dlg_Box}, "").

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME theList

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL theList Dialog-Frame

ON DEFAULT-ACTION OF theList IN FRAME Dialog-Frame

DO:

    theList = theList:SCREEN-VALUE.

    apply "GO" to frame Dialog-frame. 

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL theList Dialog-Frame

ON VALUE-CHANGED OF theList IN FRAME Dialog-Frame

DO:

    if theList = theList:SCREEN-VALUE then return.

    

    theList = theList:SCREEN-VALUE.  

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 





/* ***************************  Main Block  *************************** */



/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */

IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?

THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.





/* Now enable the interface and wait for the exit condition.            */

/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */

MAIN-BLOCK:

DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  RUN enable_UI.

  

  /*

   * Init the list box

   */

  assign 

      theList:LIST-ITEMS = itemList

      theList:screen-value = defaultItem

      theList = defaultItem

  .

  if titleLine <> ? then frame {&FRAME-NAME}:TITLE = titleLine.

  run adecomm/_setcurs.p("").

  WAIT-FOR GO OF FRAME {&FRAME-NAME}.

END.

RUN disable_UI.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME Dialog-Frame.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  DISPLAY theList 

      WITH FRAME Dialog-Frame.

  ENABLE theList e Btn_Cancel Btn_Help 

      WITH FRAME Dialog-Frame.

  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





