/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*----------------------------------------------------------------------------



File: _undslid.p



Description: Undelete a SLIDER widget.



Input Parameters:  uRecId - RecID of object of interest.



Output Parameters: <None>



Author: Ravi-Chandar Ramalingam



Date Created: 26 February 1993



Modified by gfs on 03/08/96 Added support for Win95 slider

----------------------------------------------------------------------------*/

DEFINE INPUT PARAMETER uRecId AS RECID NO-UNDO.

   

{src/adm2/globals.i}

{adeuib/uniwidg.i}

{adeuib/layout.i}

{adeuib/sharvars.i}



DEFINE BUFFER parent_U FOR _U.

DEFINE BUFFER parent_L FOR _L.

DEFINE BUFFER parent_C FOR _C.



FIND _U       WHERE RECID(_U)       eq uRecId.

FIND _L       WHERE RECID(_L)       eq _U._lo-recid.

FIND _F       WHERE RECID(_F)       eq _U._x-recid.

FIND parent_U WHERE RECID(parent_U) eq _U._parent-recid.

FIND parent_L WHERE RECID(parent_L) eq parent_U._lo-recid.

FIND parent_C WHERE RECID(parent_C) eq parent_U._x-recid.



ASSIGN _F._FRAME    = parent_U._HANDLE

       _L._WIN-TYPE = parent_L._WIN-TYPE.

IF NOT _L._WIN-TYPE THEN 

 _L._HEIGHT = IF NOT _F._HORIZONTAL THEN MAX(2,INTEGER(_L._HEIGHT)) ELSE 2.

IF NOT _L._WIN-TYPE AND NOT _F._HORIZONTAL THEN _L._WIDTH = MAX(9,INTEGER(_L._WIDTH)).



CREATE SLIDER _U._HANDLE

    ASSIGN { adeuib/std_attr.i &SIZE-CHAR = YES }

           HORIZONTAL       = _F._HORIZONTAL

           MAX-VALUE        = _F._MAX-VALUE

           MIN-VALUE        = _F._MIN-VALUE

           FREQUENCY        = _F._FREQUENCY

           LARGE-TO-SMALL   = _F._LARGE-TO-SMALL

           NO-CURRENT-VALUE = _F._NO-CURRENT-VALUE

      TRIGGERS:

           {adeuib/std_trig.i}

      END TRIGGERS.



CASE _F._TIC-MARKS:

  WHEN "TOP/LEFT" THEN

    IF _F._HORIZONTAL THEN _U._HANDLE:TIC-MARKS = "TOP".

    ELSE _U._HANDLE:TIC-MARKS = "LEFT".

  WHEN "BOTTOM/RIGHT" THEN

    IF _F._HORIZONTAL THEN _U._HANDLE:TIC-MARKS = "BOTTOM".

    ELSE _U._HANDLE:TIC-MARKS = "RIGHT".

  OTHERWISE _U._HANDLE:TIC-MARKS = _F._TIC-MARKS.

END CASE.                                                       



IF _DynamicsIsRunning THEN DO:

  IF LOOKUP(_U._CLASS-NAME,  

            DYNAMIC-FUNCTION("getClassChildrenFromDB":U IN gshRepositoryManager,

                             INPUT "DataField":U)) <> 0 THEN

     /* Attach the edit master popup */

    RUN createDataFieldPopup IN _h_uib (_U._HANDLE).

END.  /* If ICF is running */



/* Assign Handles that we now know */

ASSIGN  {adeuib/std_uf.i &SECTION = "HANDLES"} .



/* Place object within frame boundary. */

{adeuib/onframe.i

   &_whFrameHandle = "_F._FRAME"

   &_whObjHandle   = "_U._HANDLE"

   &_lvHidden      = _L._REMOVE-FROM-LAYOUT}



IF NOT _L._NO-LABELS THEN DO:  /* Note: we allow labels for dynamic sliders */

  /* Add a label to the current widget */

  { adeuib/addlabel.i }



  /* NOTE: _showlbl.p runs onframe to guarantee that the object is within

     frame boundary. */

  RUN adeuib/_showlbl.p (INPUT _U._HANDLE).

END.  /* If NOT no-label */



/* Make sure the Universal Widget Record is "correct" by reading the actually

   instantiated values. */

ASSIGN  {adeuib/std_uf.i &section = "GEOMETRY"} .



{ adeuib/rstrtrg.i } /* Restore triggers */

_U._HANDLE:SCREEN-VALUE = _F._INITIAL-DATA.

