&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI ADM1

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS V-table-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File:



  Description: from VIEWER.W - Template for SmartViewer Objects



  Input Parameters:

      <none>



  Output Parameters:

      <none>



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */

{adeuib/gridvars.i}



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartViewer

&Scoped-define DB-AWARE no



&Scoped-define ADM-SUPPORTED-LINKS Record-Source,Record-Target,TableIO-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS grid_wdth grid_hgt grid_factor_h ~

grid_factor_v grid_lo_unit 

&Scoped-Define DISPLAYED-OBJECTS grid_wdth grid_hgt grid_factor_h ~

grid_factor_v grid_lo_unit 



/* Custom List Definitions                                              */

/* ADM-CREATE-FIELDS,ADM-ASSIGN-FIELDS,List-3,List-4,List-5,List-6      */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */

DEFINE VARIABLE grid_factor_h AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 

     LABEL "Horizontal" 

     VIEW-AS FILL-IN 

     SIZE 12 BY 1 NO-UNDO.



DEFINE VARIABLE grid_factor_v AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 

     LABEL "Vertical" 

     VIEW-AS FILL-IN 

     SIZE 12 BY 1 NO-UNDO.



DEFINE VARIABLE grid_hgt AS DECIMAL FORMAT "->>,>>9.99":U INITIAL 0 

     LABEL "Height" 

     VIEW-AS FILL-IN 

     SIZE 12 BY 1 NO-UNDO.



DEFINE VARIABLE grid_wdth AS DECIMAL FORMAT "->>,>>9.99":U INITIAL 0 

     LABEL "Width" 

     VIEW-AS FILL-IN 

     SIZE 12 BY 1 NO-UNDO.



DEFINE VARIABLE grid_lo_unit AS LOGICAL 

     VIEW-AS RADIO-SET HORIZONTAL

     RADIO-BUTTONS 

          "Character", yes,

"Pixel", no

     SIZE 27 BY 1.19 NO-UNDO.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     grid_wdth AT ROW 2.67 COL 18 COLON-ALIGNED

     grid_hgt AT ROW 2.67 COL 43 COLON-ALIGNED

     grid_factor_h AT ROW 5.52 COL 18 COLON-ALIGNED

     grid_factor_v AT ROW 5.52 COL 43 COLON-ALIGNED

     grid_lo_unit AT ROW 7.19 COL 20 NO-LABEL

     "Grid Unit Size:  (Graphical Windows Only)" VIEW-AS TEXT

          SIZE 52 BY .62 AT ROW 1.71 COL 3

     "Grid Units Between Major Lines:" VIEW-AS TEXT

          SIZE 52 BY .62 AT ROW 4.57 COL 3

     "Layout Units:" VIEW-AS TEXT

          SIZE 13 BY .62 AT ROW 7.43 COL 7

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1

         SIZE 74.8 BY 9.24.





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartViewer

   Allow: Basic,DB-Fields

   Frames: 1

   Add Fields to: EXTERNAL-TABLES

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW V-table-Win ASSIGN

         HEIGHT             = 9.24

         WIDTH              = 74.8.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB V-table-Win 

/* ************************* Included-Libraries *********************** */



{src/adm2/viewer.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW V-table-Win

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE                                                          */

ASSIGN 

       FRAME F-Main:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK V-table-Win 





/* ***************************  Main Block  *************************** */



  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

    RUN initializeObject.        

  &ENDIF         

  

  /************************ INTERNAL PROCEDURES ********************/



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE assign-new-values V-table-Win 

PROCEDURE assign-new-values :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  DO WITH FRAME {&FRAME-NAME}:

    ASSIGN {&ENABLED-OBJECTS}.



    ASSIGN _cur_grid_wdth     = grid_wdth

           _cur_grid_hgt      = grid_hgt

           _cur_grid_factor_h = grid_factor_h

           _cur_grid_factor_v = grid_factor_v

           _cur_layout_unit   = grid_lo_unit.

  END.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI V-table-Win  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set-init V-table-Win 

PROCEDURE set-init :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

   ASSIGN grid_wdth     = _cur_grid_wdth

          grid_hgt      = _cur_grid_hgt

          grid_factor_h = _cur_grid_factor_h

          grid_factor_v = _cur_grid_factor_v

          grid_lo_unit  = _cur_layout_unit.



   DISPLAY grid_wdth grid_hgt grid_factor_h grid_factor_v grid_lo_unit WITH

           FRAME {&FRAME-NAME}.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



