&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI ADM1

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS V-table-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File:



  Description: from VIEWER.W - Template for SmartViewer Objects



  Input Parameters:

      <none>



  Output Parameters:

      <none>



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



{adecomm/adestds.i}   /* Standard Definitions             */

{adeuib/uniwidg.i}    /* Universal widgt records          */

{adeuib/sharvars.i}   /* Shared variables                 */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartViewer

&Scoped-define DB-AWARE no



&Scoped-define ADM-SUPPORTED-LINKS Record-Source,Record-Target,TableIO-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS PrintPageLength PrintFont PrintDialog 

&Scoped-Define DISPLAYED-OBJECTS PrintPageLength PrintFont PrintDialog 



/* Custom List Definitions                                              */

/* ADM-CREATE-FIELDS,ADM-ASSIGN-FIELDS,List-3,List-4,List-5,List-6      */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */

DEFINE VARIABLE PrintFont AS INTEGER FORMAT ">9":U INITIAL 0 

     LABEL "Font" 

     VIEW-AS COMBO-BOX INNER-LINES 5

     LIST-ITEM-PAIRS "Item 1",0

     DROP-DOWN-LIST

     SIZE 50 BY 1 NO-UNDO.



DEFINE VARIABLE PrintPageLength AS INTEGER FORMAT ">>9":U INITIAL 0 

     LABEL "Page Length" 

     VIEW-AS FILL-IN 

     SIZE 6 BY 1 NO-UNDO.



DEFINE VARIABLE PrintDialog AS LOGICAL INITIAL no 

     LABEL "Use Print Dialog Box" 

     VIEW-AS TOGGLE-BOX

     SIZE 23 BY .81 NO-UNDO.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     PrintPageLength AT ROW 1.19 COL 1.6

     PrintFont AT ROW 2.67 COL 13 COLON-ALIGNED

     PrintDialog AT ROW 4.05 COL 15

     "(#Lines, 0 for Continuous)" VIEW-AS TEXT

          SIZE 26 BY .62 AT ROW 1.38 COL 23.6

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartViewer

   Allow: Basic,DB-Fields

   Frames: 1

   Add Fields to: EXTERNAL-TABLES

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW V-table-Win ASSIGN

         HEIGHT             = 4.38

         WIDTH              = 65.2.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB V-table-Win 

/* ************************* Included-Libraries *********************** */



{src/adm2/viewer.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW V-table-Win

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE Size-to-Fit                                              */

ASSIGN 

       FRAME F-Main:SCROLLABLE       = FALSE

       FRAME F-Main:HIDDEN           = TRUE.



/* SETTINGS FOR FILL-IN PrintPageLength IN FRAME F-Main

   ALIGN-L                                                              */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK V-table-Win 





/* ***************************  Main Block  *************************** */



  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

    RUN dispatch IN THIS-PROCEDURE ('initialize':U).        

  &ENDIF         

  

  /************************ INTERNAL PROCEDURES ********************/



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE assign-new-values V-table-Win 

PROCEDURE assign-new-values :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

 DO WITH FRAME {&FRAME-NAME}:

    ASSIGN PrintPageLength

           PrintFont

           PrintDialog.



    ASSIGN _print_pg_length = PrintPageLength

           _print_font      = PrintFont

           _print_dialog    = PrintDialog.



 END.  /* DO WITH FRAME {&FRAME-NAME} */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI V-table-Win  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject V-table-Win 

PROCEDURE initializeObject :

/*------------------------------------------------------------------------------

  Purpose:     Override standard ADM method

  Notes:       

------------------------------------------------------------------------------*/

DEFINE VARIABLE cFontString AS CHARACTER         NO-UNDO.

DEFINE VARIABLE cFontItems  AS CHARACTER         NO-UNDO.

DEFINE VARIABLE i           AS INTEGER INITIAL 0 NO-UNDO.



  /* Code placed here will execute PRIOR to standard behavior. */

  PrintFont:DELIMITER IN FRAME {&FRAME-NAME} = CHR(1).

  DO WHILE i < FONT-TABLE:NUM-ENTRIES:

    GET-KEY-VALUE SECTION "Fonts" KEY "Font" + STRING(i) VALUE cFontString.

    IF i = 0 THEN.

    ELSE cFontItems = cFontItems + CHR(1).

    cFontItems = cFontItems + cFontString + CHR(1) + STRING(i).

    i = i + 1.

  END.

  

  PrintFont:LIST-ITEM-PAIRS IN FRAME {&FRAME-NAME} = cFontItems.



  /* Dispatch standard ADM method.                             */

 RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set-init V-table-Win 

PROCEDURE set-init :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  /* PrintFont is assigned default value of 2 if the print font preference is

     not part of the font table (it may have been removed from the registry

     or ini file by the user) */

  ASSIGN PrintPageLength = _print_pg_length

         PrintFont       = IF _print_font > (FONT-TABLE:NUM-ENTRIES - 1)

                             THEN 2 ELSE _print_font

         PrintDialog     = _print_dialog.



  DISPLAY {&DISPLAYED-OBJECTS} WITH FRAME F-Main.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



