&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

&ANALYZE-RESUME

/* Connected Databases 

          sports           PROGRESS

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS V-table-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File:



  Description: from VIEWER.W - Template for SmartViewer Objects



  Input Parameters:

      <none>



  Output Parameters:

      <none>



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartViewer



&Scoped-define ADM-SUPPORTED-LINKS Record-Source,Record-Target,TableIO-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* External Tables                                                      */

&Scoped-define EXTERNAL-TABLES Item

&Scoped-define FIRST-EXTERNAL-TABLE Item





/* Need to scope the external tables to this procedure                  */

DEFINE QUERY external_tables FOR Item.

/* Standard List Definitions                                            */

&Scoped-Define ENABLED-FIELDS Item.Item-num 

&Scoped-define FIELD-PAIRS~

 ~{&FP1}Item-num ~{&FP2}Item-num ~{&FP3}

&Scoped-define ENABLED-TABLES Item

&Scoped-define FIRST-ENABLED-TABLE Item

&Scoped-Define ENABLED-OBJECTS RECT-1 

&Scoped-Define DISPLAYED-FIELDS Item.Item-num 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of handles for OCX Containers                            */

DEFINE VARIABLE Spinner AS WIDGET-HANDLE NO-UNDO.

DEFINE VARIABLE chSpinner AS COMPONENT-HANDLE NO-UNDO.



/* Definitions of the field level widgets                               */

DEFINE RECTANGLE RECT-1

     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 

     SIZE 28.8 BY 1.62.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     Item.Item-num AT ROW 1.24 COL 14 COLON-ALIGNED NO-LABEL

          VIEW-AS FILL-IN 

          SIZE 9 BY 1.19

     RECT-1 AT ROW 1.05 COL 1.2

     "Item Number" VIEW-AS TEXT

          SIZE 13 BY .62 AT ROW 1.48 COL 3

     SPACE(12.00) SKIP(0.33)

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartViewer

   External Tables: sports.Item

   Allow: Basic,DB-Fields

   Frames: 1

   Add Fields to: EXTERNAL-TABLES

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT."

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW V-table-Win ASSIGN

         HEIGHT             = 1.76

         WIDTH              = 30.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME





/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW V-table-Win

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE Size-to-Fit                                              */

ASSIGN 

       FRAME F-Main:SCROLLABLE       = FALSE

       FRAME F-Main:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB V-table-Win 

/* ************************* Included-Libraries *********************** */



{src/adm/method/viewer.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME







/* **********************  Create OCX Containers  ********************** */



&ANALYZE-SUSPEND _CREATE-DYNAMIC



&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN



/* OCX BINARY:FILENAME is: adm\samples\v-spin.wrx */



CREATE CONTROL-FRAME Spinner ASSIGN

       FRAME        = FRAME F-Main:HANDLE

       ROW          = 1.24

       COLUMN       = 25

       HEIGHT       = 1.19

       WIDTH        = 3

       HIDDEN       = no

       SENSITIVE    = yes.



PROCEDURE adm-create-controls:

      Spinner:NAME = "Spinner":U .

/* Spinner OCXINFO:CREATE-CONTROL from: {EAF26C8F-9586-101B-9306-0020AF234C9D} type: CSSpin */

      Spinner:MOVE-AFTER(Item.Item-num:HANDLE IN FRAME F-Main).



END PROCEDURE.



&ENDIF



&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */





/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME Spinner

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Spinner V-table-Win

PROCEDURE Spinner.CSSpin.SpinDown .

/*------------------------------------------------------------------------------

  Purpose:     Decrement Item record

  Parameters:  None required for OCX.

  Notes:       

------------------------------------------------------------------------------*/

 RUN notify IN THIS-PROCEDURE ( 'get-prev,RECORD-SOURCE':U ). 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Spinner V-table-Win

PROCEDURE Spinner.CSSpin.SpinUp .

/*------------------------------------------------------------------------------

  Purpose:     Increment Item record

  Parameters:  None required for OCX.

  Notes:       

------------------------------------------------------------------------------*/ 

 RUN notify IN THIS-PROCEDURE ( 'get-next,RECORD-SOURCE':U ). 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK V-table-Win 





/* ***************************  Main Block  *************************** */

  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

    RUN dispatch IN THIS-PROCEDURE ('initialize':U).        

  &ENDIF         

  

  /************************ INTERNAL PROCEDURES ********************/



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-row-available V-table-Win _ADM-ROW-AVAILABLE

PROCEDURE adm-row-available :

/*------------------------------------------------------------------------------

  Purpose:     Dispatched to this procedure when the Record-

               Source has a new row available.  This procedure

               tries to get the new row (or foriegn keys) from

               the Record-Source and process it.

  Parameters:  <none>

------------------------------------------------------------------------------*/



  /* Define variables needed by this internal procedure.             */

  {src/adm/template/row-head.i}



  /* Create a list of all the tables that we need to get.            */

  {src/adm/template/row-list.i "Item"}



  /* Get the record ROWID's from the RECORD-SOURCE.                  */

  {src/adm/template/row-get.i}



  /* FIND each record specified by the RECORD-SOURCE.                */

  {src/adm/template/row-find.i "Item"}



  /* Process the newly available records (i.e. display fields,

     open queries, and/or pass records on to any RECORD-TARGETS).    */

  {src/adm/template/row-end.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load V-table-Win _CONTROL-LOAD

PROCEDURE control_load :

/*------------------------------------------------------------------------------

  Purpose:     Load the OCXs    

  Parameters:  <none>

  Notes:       Here we load, initialize and make visible the 

               OCXs in the interface.                        

------------------------------------------------------------------------------*/



&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.

DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.



OCXFile = SEARCH( "adm\samples\v-spin.wrx":U ).



IF OCXFile <> ? THEN DO:

  ASSIGN

    chSpinner = Spinner:COM-HANDLE

    UIB_S = chSpinner:LoadControls( OCXFile, "Spinner":U)

  .

  RUN DISPATCH IN THIS-PROCEDURE("initialize-controls":U) NO-ERROR.

END.

ELSE MESSAGE "The file, adm\samples\v-spin.wrx, could not be found." skip

             "The controls cannot be loaded."

             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".



&ENDIF



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI V-table-Win _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-row-available V-table-Win 

PROCEDURE local-row-available :

/*------------------------------------------------------------------------------

  Purpose:     Override standard ADM method

  Notes:       

------------------------------------------------------------------------------*/

  

  /* Code placed here will execute PRIOR to standard behavior. */



  /* Dispatch standard ADM method.                             */

  RUN dispatch IN THIS-PROCEDURE ( INPUT 'row-available':U ) .



  /* Code placed here will execute AFTER standard behavior.    */

  IF AVAILABLE Item THEN 

    ASSIGN chSpinner:CSSpin:Value = Item.Item-num.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE send-records V-table-Win _ADM-SEND-RECORDS

PROCEDURE send-records :

/*------------------------------------------------------------------------------

  Purpose:     Send record ROWID's for all tables used by

               this file.

  Parameters:  see template/snd-head.i

------------------------------------------------------------------------------*/



  /* Define variables needed by this internal procedure.               */

  {src/adm/template/snd-head.i}



  /* For each requested table, put it's ROWID in the output list.      */

  {src/adm/template/snd-list.i "Item"}



  /* Deal with any unexpected table requests before closing.           */

  {src/adm/template/snd-end.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE state-changed V-table-Win 

PROCEDURE state-changed :

/* -----------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

-------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p-issuer-hdl AS HANDLE    NO-UNDO.

  DEFINE INPUT PARAMETER p-state      AS CHARACTER NO-UNDO.



  CASE p-state:

      /* Object instance CASEs can go here to replace standard behavior

         or add new cases. */

      {src/adm/template/vstates.i}

  END CASE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





