&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

&ANALYZE-RESUME

/* Connected Databases 

*/

&Scoped-define WINDOW-NAME W-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS W-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: 



  Description: from cntnrwin.w - ADM SmartWindow Template



  Input Parameters:

      <none>



  Output Parameters:

      <none>



  History: 

          

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartWindow



&Scoped-define ADM-CONTAINER WINDOW



&Scoped-define ADM-SUPPORTED-LINKS Record-Target



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS RECT-2 Btn_Done 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define the widget handle for the window                              */

DEFINE VAR W-Win AS WIDGET-HANDLE NO-UNDO.



/* Definitions of handles for SmartObjects                              */

DEFINE VARIABLE h_p-savres AS HANDLE NO-UNDO.

DEFINE VARIABLE h_V-CUSADD AS HANDLE NO-UNDO.



/* Definitions of the field level widgets                               */

DEFINE BUTTON Btn_Done DEFAULT 

     LABEL "&Close" 

     SIZE 12.6 BY 1.62

     BGCOLOR 8 FONT 4.



DEFINE RECTANGLE RECT-2

     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 

     SIZE 15 BY 2.19.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     Btn_Done AT ROW 9.33 COL 60

     RECT-2 AT ROW 9.1 COL 59

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS TOP-ONLY NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1.05

         SIZE 73.8 BY 10.62

         DEFAULT-BUTTON Btn_Done.



 



/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartWindow

   Allow: Basic,Browse,DB-Fields,Query,Smart,Window

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

IF SESSION:DISPLAY-TYPE = "GUI":U THEN

  CREATE WINDOW W-Win ASSIGN

         HIDDEN             = YES

         TITLE              = "Customer Update"

         HEIGHT             = 10.57

         WIDTH              = 73.2

         MAX-HEIGHT         = 28.62

         MAX-WIDTH          = 159.8

         VIRTUAL-HEIGHT     = 28.62

         VIRTUAL-WIDTH      = 159.8

         RESIZE             = no

         SCROLL-BARS        = no

         STATUS-AREA        = no

         BGCOLOR            = ?

         FGCOLOR            = ?

         THREE-D            = yes

         MESSAGE-AREA       = no

         SENSITIVE          = yes.

ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

/* END WINDOW DEFINITION                                                */

&ANALYZE-RESUME





/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW W-Win

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

   L-To-R                                                               */

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(W-Win)

THEN W-Win:HIDDEN = yes.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB W-Win 

/* ************************* Included-Libraries *********************** */



{src/adm/method/containr.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME W-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL W-Win W-Win

ON END-ERROR OF W-Win /* Customer Update */

OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:

  /* This case occurs when the user presses the "Esc" key.

     In a persistently run window, just ignore this.  If we did not, the

     application would exit. */

  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL W-Win W-Win

ON WINDOW-CLOSE OF W-Win /* Customer Update */

DO:

  /* This ADM code must be left here in order for the SmartWindow

     and its descendents to terminate properly on exit. */

  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_Done

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Done W-Win

ON CHOOSE OF Btn_Done IN FRAME F-Main /* Close */

DO:

  RUN new-state ('change-page-1').

  &IF DEFINED (adm-panel) <> 0 &THEN

      RUN dispatch IN THIS-PROCEDURE ('exit').      

  &ELSE

      APPLY "CLOSE":U TO THIS-PROCEDURE.

  &ENDIF

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK W-Win 





/* ***************************  Main Block  *************************** */



/* Include custom  Main Block code for SmartWindows. */

{src/adm/template/windowmn.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects W-Win _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/

  DEFINE VARIABLE adm-current-page  AS INTEGER NO-UNDO.



  RUN get-attribute IN THIS-PROCEDURE ('Current-Page':U).

  ASSIGN adm-current-page = INTEGER(RETURN-VALUE).



  CASE adm-current-page: 



    WHEN 0 THEN DO:

       RUN init-object IN THIS-PROCEDURE (

             INPUT  'adm/samples/v-cusadd.w':U ,

             INPUT  FRAME F-Main:HANDLE ,

             INPUT  'Layout = ':U ,

             OUTPUT h_V-CUSADD ).

       RUN set-position IN h_V-CUSADD ( 1.00 , 1.00 ) NO-ERROR.

       /* Size in UIB:  ( 7.62 , 73.00 ) */



       RUN init-object IN THIS-PROCEDURE (

             INPUT  'adm/samples/p-savres.w':U ,

             INPUT  FRAME F-Main:HANDLE ,

             INPUT  'Edge-Pixels = 2,

                     SmartPanelType = Save,

                     AddFunction = One-Record':U ,

             OUTPUT h_p-savres ).

       RUN set-position IN h_p-savres ( 9.10 , 19.00 ) NO-ERROR.

       RUN set-size IN h_p-savres ( 2.19 , 28.00 ) NO-ERROR.



       /* Links to SmartViewer h_V-CUSADD. */

       RUN add-link IN adm-broker-hdl ( h_p-savres , 'TableIO':U , h_V-CUSADD ).

       RUN add-link IN adm-broker-hdl ( THIS-PROCEDURE , 'Record':U , h_V-CUSADD ).



       /* Adjust the tab order of the smart objects. */

       RUN adjust-tab-order IN adm-broker-hdl ( h_V-CUSADD ,

               h_p-savres , 'BEFORE':U ).

       RUN adjust-tab-order IN adm-broker-hdl ( h_p-savres ,

               h_V-CUSADD , 'AFTER':U ).

    END. /* Page 0 */



  END CASE.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-row-available W-Win _ADM-ROW-AVAILABLE

PROCEDURE adm-row-available :

/*------------------------------------------------------------------------------

  Purpose:     Dispatched to this procedure when the Record-

               Source has a new row available.  This procedure

               tries to get the new row (or foriegn keys) from

               the Record-Source and process it.

  Parameters:  <none>

------------------------------------------------------------------------------*/



  /* Define variables needed by this internal procedure.             */

  {src/adm/template/row-head.i}



  /* Process the newly available records (i.e. display fields,

     open queries, and/or pass records on to any RECORD-TARGETS).    */

  {src/adm/template/row-end.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI W-Win _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Delete the WINDOW we created */

  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(W-Win)

  THEN DELETE WIDGET W-Win.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI W-Win _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  ENABLE RECT-2 Btn_Done 

      WITH FRAME F-Main IN WINDOW W-Win.

  {&OPEN-BROWSERS-IN-QUERY-F-Main}

  VIEW W-Win.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-exit W-Win 

PROCEDURE local-exit :

/* -----------------------------------------------------------

  Purpose:  Starts an "exit" by APPLYing CLOSE event, which starts "destroy".

  Parameters:  <none>

  Notes:    If activated, should APPLY CLOSE, *not* dispatch adm-exit.   

-------------------------------------------------------------*/

   APPLY "CLOSE":U TO THIS-PROCEDURE.

   

   RETURN.

       

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE send-records W-Win _ADM-SEND-RECORDS

PROCEDURE send-records :

/*------------------------------------------------------------------------------

  Purpose:     Send record ROWID's for all tables used by

               this file.

  Parameters:  see template/snd-head.i

------------------------------------------------------------------------------*/



  /* SEND-RECORDS does nothing because there are no External

     Tables specified for this SmartWindow, and there are no

     tables specified in any contained Browse, Query, or Frame. */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE state-changed W-Win 

PROCEDURE state-changed :

/* -----------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

-------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p-issuer-hdl AS HANDLE NO-UNDO.

  DEFINE INPUT PARAMETER p-state AS CHARACTER NO-UNDO.

  

  DEFINE VARIABLE log-var AS LOGICAL                  NO-UNDO.

  CASE p-state:

    WHEN 'on-top' THEN log-var = {&WINDOW-NAME}:MOVE-TO-TOP().      

  END.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





