&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

/* Procedure Description

"ADE Wizard signoff screen"

*/

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME C-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: _wizend.w



  Description: Last screen of Wizard. 



  Input Parameters:

      hWizard (handle) - handle of Wizard dialog



  Output Parameters:

      <none>



  Author: Gerry Seidl



  Created: 4/5/95



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */

DEFINE INPUT PARAMETER hWizard AS WIDGET-HANDLE NO-UNDO.



/* Local Variable Definitions ---                                       */

DEFINE VARIABLE objtype AS CHARACTER NO-UNDO.

DEFINE VARIABLE h       AS HANDLE    NO-UNDO.

DEFINE VARIABLE l       AS LOGICAL   NO-UNDO.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE WINDOW



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME DEFAULT-FRAME



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS IMAGE-4 RECT-4 

&Scoped-Define DISPLAYED-OBJECTS msg msg1 msg2 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define the widget handle for the window                              */

DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.



/* Definitions of the field level widgets                               */

DEFINE VARIABLE msg AS CHARACTER FORMAT "X(256)":U 

      VIEW-AS TEXT 

     SIZE 39 BY 1.05 NO-UNDO.



DEFINE VARIABLE msg1 AS CHARACTER FORMAT "X(256)":U 

      VIEW-AS TEXT 

     SIZE 39 BY 1.05 NO-UNDO.



DEFINE VARIABLE msg2 AS CHARACTER FORMAT "X(256)":U INITIAL "You may now save and close this object." 

      VIEW-AS TEXT 

     SIZE 39 BY 1.05 NO-UNDO.



DEFINE IMAGE IMAGE-4

     FILENAME "adeicon/wizdone":U CONVERT-3D-COLORS

     SIZE 41 BY 7.71.



DEFINE RECTANGLE RECT-4

     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 

     SIZE 41 BY 7.29.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME DEFAULT-FRAME

     msg AT ROW 2.37 COL 44 NO-LABEL

     msg1 AT ROW 3.8 COL 44 NO-LABEL

     msg2 AT ROW 5.23 COL 44 NO-LABEL

     IMAGE-4 AT ROW 1.9 COL 2

     RECT-4 AT ROW 1.9 COL 43

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         THREE-D 

         AT COL 1 ROW 1

         SIZE 83.6 BY 9.76

         FONT 4.



 



/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: WINDOW

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* SUPPRESS Window definition (used by the UIB) 

IF SESSION:DISPLAY-TYPE = "GUI":U THEN

  CREATE WINDOW C-Win ASSIGN

         HIDDEN             = YES

         TITLE              = "<insert title>"

         HEIGHT             = 9.71

         WIDTH              = 96.2

         MAX-HEIGHT         = 20.67

         MAX-WIDTH          = 96.2

         VIRTUAL-HEIGHT     = 20.67

         VIRTUAL-WIDTH      = 96.2

         RESIZE             = no

         SCROLL-BARS        = no

         STATUS-AREA        = no

         BGCOLOR            = ?

         FGCOLOR            = ?

         KEEP-FRAME-Z-ORDER = yes

         THREE-D            = yes

         MESSAGE-AREA       = no

         SENSITIVE          = yes.

ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

                                                                        */

&ANALYZE-RESUME

ASSIGN C-Win = CURRENT-WINDOW.







/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW C-Win

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME DEFAULT-FRAME

   UNDERLINE Default                                                    */

/* SETTINGS FOR FILL-IN msg IN FRAME DEFAULT-FRAME

   NO-ENABLE ALIGN-L                                                    */

/* SETTINGS FOR FILL-IN msg1 IN FRAME DEFAULT-FRAME

   NO-ENABLE ALIGN-L                                                    */

/* SETTINGS FOR FILL-IN msg2 IN FRAME DEFAULT-FRAME

   NO-ENABLE ALIGN-L                                                    */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME DEFAULT-FRAME

/* Query rebuild information for FRAME DEFAULT-FRAME

     _Query            is NOT OPENED

*/  /* FRAME DEFAULT-FRAME */

&ANALYZE-RESUME



 









/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME C-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win

ON END-ERROR OF C-Win /* <insert title> */

OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:

  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win

ON WINDOW-CLOSE OF C-Win /* <insert title> */

DO:

  /* These events will close the window and terminate the procedure.      */

  /* (NOTE: this will override any user-defined triggers previously       */

  /*  defined on the window.)                                             */

  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 





/* ***************************  Main Block  *************************** */

ASSIGN FRAME {&FRAME-NAME}:FRAME    = hwizard

       FRAME {&FRAME-NAME}:HIDDEN   = NO

       FRAME {&FRAME-NAME}:HEIGHT-P =  FRAME {&FRAME-NAME}:VIRTUAL-HEIGHT-P

       FRAME {&FRAME-NAME}:WIDTH-P  =  FRAME {&FRAME-NAME}:VIRTUAL-WIDTH-P

       .



h = hwizard:FIRST-CHILD. /* field-group */

h = h:FIRST-CHILD. /* first widget */

DO WHILE h <> ?:

  IF h:NAME = "b_Finish":U THEN LEAVE. /* find finish button */

  h = h:NEXT-SIBLING.

END.



ASSIGN objtype = ENTRY(1,hWizard:TITLE," ":U).

IF h:SENSITIVE = NO THEN

  ASSIGN msg = "You have not completed this"

         msg1 = objtype + "!"

         msg2 = "Go back or press cancel."

         l = IMAGE-4:LOAD-IMAGE("adeicon/wizndone":U).

ELSE      

  ASSIGN msg = "Congratulations!"

         msg1 = "You have completed this " + objtype + "!"

         IMAGE-4:HIDDEN = no.

       

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */

ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 

       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.



/* The CLOSE event can be used from inside or outside the procedure to  */

/* terminate it.                                                        */

ON CLOSE OF THIS-PROCEDURE 

   RUN disable_UI.



/* Best default for GUI applications is...                              */

PAUSE 0 BEFORE-HIDE.



/* Now enable the interface and wait for the exit condition.            */

/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */

MAIN-BLOCK:

DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  RUN enable_UI.

  IF NOT THIS-PROCEDURE:PERSISTENT THEN

    WAIT-FOR CLOSE OF THIS-PROCEDURE.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME DEFAULT-FRAME.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  DISPLAY msg msg1 msg2 

      WITH FRAME DEFAULT-FRAME.

  ENABLE IMAGE-4 RECT-4 

      WITH FRAME DEFAULT-FRAME.

  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}

  VIEW C-Win.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





