&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r2 GUI

&ANALYZE-RESUME

/* Connected Databases 

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&Scoped-define FRAME-NAME D-Dialog

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS D-Dialog 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: advqedit.w



  Description: A editor for Advanced Query section in a SmartBrowser or

               SmartQuery



  Input Parameters:

      p_context - Context of the XFTR code section

      

  Input-Output parameters:

      p_code    - The code to update

      

  Output Parameters:

      <none>



  Author: Wm.T.Wood 



  Created: December 22, 1995

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */

&IF "{&UIB_is_Running}" eq "" &THEN

  DEFINE INPUT        PARAMETER p_context AS INTEGER NO-UNDO.

  DEFINE INPUT-OUTPUT PARAMETER p_code    AS CHAR NO-UNDO.

&ELSE

  DEFINE VARIABLE p_context AS INTEGER NO-UNDO.

  DEFINE VARIABLE p_code    AS CHAR NO-UNDO.

  /* Testing code */

  p_code =

"/* STRUCTURED-DATA

<SORTBY-OPTIONS>

Order Number|Sports.Order.Order-num

Cust-Num|Sports.Order.Cust-num

Sales-Rep|Sports.Order.Sales-Rep

</SORTBY-OPTIONS> */".



&ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDialog



&Scoped-define ADM-CONTAINER DIALOG-BOX



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME D-Dialog



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "SmartDialogCues" D-Dialog _INLINE

/* Actions: adecomm/_so-cue.w ? adecomm/_so-cued.p ? adecomm/_so-cuew.p */

/* SmartDialog,uib,49267

Destroy on next read */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* ***********************  Control Definitions  ********************** */



/* Define a dialog box                                                  */



/* Definitions of handles for SmartObjects                              */

DEFINE VARIABLE h_filtedit AS HANDLE NO-UNDO.

DEFINE VARIABLE h_folder AS HANDLE NO-UNDO.

DEFINE VARIABLE h_sortpage AS HANDLE NO-UNDO.



/* ************************  Frame Definitions  *********************** */



DEFINE FRAME D-Dialog

     SPACE(78.72) SKIP(10.85)

    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 

         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 

         TITLE "Advanced Query Options".



 



/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDialog

   Allow: Basic,Browse,DB-Fields,Query,Smart

   Design Page: 1

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS





/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

ASSIGN 

       FRAME D-Dialog:SCROLLABLE       = FALSE

       FRAME D-Dialog:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX D-Dialog

/* Query rebuild information for DIALOG-BOX D-Dialog

     _Options          = "SHARE-LOCK"

     _Query            is NOT OPENED

*/  /* DIALOG-BOX D-Dialog */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB D-Dialog 

/* ************************* Included-Libraries *********************** */



{src/adm/method/containr.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME D-Dialog

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL D-Dialog D-Dialog

ON WINDOW-CLOSE OF FRAME D-Dialog /* Advanced Query Options */

DO:  

  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */

  APPLY "END-ERROR":U TO SELF.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK D-Dialog 





/* ***************************  Main Block  *************************** */



{src/adm/template/dialogmn.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects D-Dialog _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/

  DEFINE VARIABLE adm-current-page AS INTEGER NO-UNDO.



  RUN get-attribute IN THIS-PROCEDURE ('Current-Page':U).

  ASSIGN adm-current-page = INTEGER(RETURN-VALUE).



  CASE adm-current-page: 



    WHEN 0 THEN DO:

       RUN init-object IN THIS-PROCEDURE (

             INPUT  'adm/objects/folder.w':U ,

             INPUT  FRAME D-Dialog:HANDLE ,

             INPUT  'FOLDER-LABELS = Sort Options|Filters,

                     FOLDER-TAB-TYPE = 1':U ,

             OUTPUT h_folder ).

       RUN set-position IN h_folder ( 1.27 , 2.00 ) NO-ERROR.

       RUN set-size IN h_folder ( 10.50 , 77.00 ) NO-ERROR.



       /* Links to SmartFolder h_folder. */

       RUN add-link IN adm-broker-hdl ( h_folder , 'Page':U , THIS-PROCEDURE ).



    END. /* Page 0 */



    WHEN 1 THEN DO:

       RUN init-object IN THIS-PROCEDURE (

             INPUT  'adm/support/sortedit.w':U ,

             INPUT  FRAME D-Dialog:HANDLE ,

             INPUT  '':U ,

             OUTPUT h_sortpage ).

       RUN set-position IN h_sortpage ( 2.62 , 3.00 ) NO-ERROR.

       /* Size in UIB:  ( 8.62 , 74.00 ) */



    END. /* Page 1 */



    WHEN 2 THEN DO:

       RUN init-object IN THIS-PROCEDURE (

             INPUT  'adm/support/filtedit.w':U ,

             INPUT  FRAME D-Dialog:HANDLE ,

             INPUT  '':U ,

             OUTPUT h_filtedit ).

       RUN set-position IN h_filtedit ( 2.62 , 3.00 ) NO-ERROR.

       /* Size in UIB:  ( 8.62 , 74.00 ) */



    END. /* Page 2 */



  END CASE.

  /* Select a Startup page. */

  IF adm-current-page eq 0 

  THEN RUN select-page IN THIS-PROCEDURE ( 1 ).



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI D-Dialog _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME D-Dialog.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI D-Dialog _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  VIEW FRAME D-Dialog.

  {&OPEN-BROWSERS-IN-QUERY-D-Dialog}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get-xftrcode D-Dialog 

PROCEDURE get-xftrcode :

/*------------------------------------------------------------------------------

  Purpose:     Return the code for the XFTR section.

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  RETURN p_code.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-change-page D-Dialog 

PROCEDURE local-change-page :

/*------------------------------------------------------------------------------

  Purpose:     Override standard ADM method

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE VAR icurrent AS INTEGER NO-UNDO.

  DEFINE VAR i AS INTEGER NO-UNDO.

  DEFINE VAR page-link AS CHAR NO-UNDO.

  

  /* Tell the objects not on the current page to save their changes, if any.

     Then destroy these objects. */

  RUN get-attribute ('Current-Page':U).

  icurrent = INTEGER(RETURN-VALUE).

  DO i = 1 TO 2: /* The max page count. */

    IF i ne icurrent THEN DO:

      page-link = "Page" + RETURN-VALUE + "-Target".

      RUN notify ('save-changes,':U + page-link).

      RUN notify ('destroy,':U + page-link).

    END. /* IF... */

  END. /* DO... */



  /* Dispatch standard ADM method.                             */

  RUN dispatch IN THIS-PROCEDURE ( INPUT 'change-page':U ) .



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-initialize D-Dialog 

PROCEDURE local-initialize :

/*------------------------------------------------------------------------------

  Purpose:     Override standard ADM method

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE VAR c_info AS CHAR NO-UNDO.

  

  /* Find the context id for the procedure and store this as an attribute. */

  RUN adeuib/_uibinfo.p (p_context, ?, "PROCEDURE":U, OUTPUT c_info).

  RUN set-attribute-list ("Procedure-Context=" + c_info).



  /* Dispatch standard ADM method.                             */

  RUN dispatch IN THIS-PROCEDURE ( INPUT 'initialize':U ) .



  /* Code placed here will execute AFTER standard behavior.    */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set-xftrcode D-Dialog 

PROCEDURE set-xftrcode :

/*------------------------------------------------------------------------------

  Purpose:     Set the code for the XFTR section.

  Parameters:  p_newcode -- the new code.

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p_newcode AS CHAR NO-UNDO.

  

  p_code = p_newcode.

  

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE state-changed D-Dialog 

PROCEDURE state-changed :

/* -----------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

-------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p-issuer-hdl AS HANDLE NO-UNDO.

  DEFINE INPUT PARAMETER p-state AS CHARACTER NO-UNDO.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





