&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

/* Procedure Description

"ADM SmartWindow Object Template



Use this template to create a new window which supports SmartObjects. Draw your SmartObjects on this container and establish the appropriate SmartLinks to connect them."

*/

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME W-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS W-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: 



  Description: from cntnrwin.w - ADM SmartWindow Template



  Input Parameters:

      <none>



  Output Parameters:

      <none>



  History: 

          

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress UIB.             */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartWindow



&Scoped-define ADM-CONTAINER WINDOW



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define the widget handle for the window                              */

DEFINE VAR W-Win AS WIDGET-HANDLE NO-UNDO.



/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1

         SIZE 80 BY 17.





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartWindow Template

   Allow: Basic,Browse,DB-Fields,Query,Smart,Window

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

IF SESSION:DISPLAY-TYPE = "GUI":U THEN

  CREATE WINDOW W-Win ASSIGN

         HIDDEN             = YES

         TITLE              = "<insert SmartWindow title>"

         HEIGHT             = 17

         WIDTH              = 80

         MAX-HEIGHT         = 17

         MAX-WIDTH          = 80

         VIRTUAL-HEIGHT     = 17

         VIRTUAL-WIDTH      = 80

         RESIZE             = no

         SCROLL-BARS        = no

         STATUS-AREA        = no

         BGCOLOR            = ?

         FGCOLOR            = ?

         THREE-D            = yes

         MESSAGE-AREA       = no

         SENSITIVE          = yes.

ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

/* END WINDOW DEFINITION                                                */

&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "SmartWindowCues" W-Win _INLINE

/* Actions: adecomm/_so-cue.w ? adecomm/_so-cued.p ? adecomm/_so-cuew.p */

/* SmartWindow,ab,49271

A SmartWindow is a SmartContainer--a procedure object designed to contain other SmartObject instances. 



A SmartWindow instantiates and initializes the SmartObject instances it contains. At initialization, the SmartWindow sets the position of the instances and links them together.



USING A SMARTWINDOW



Step 1

Build your desired SmartObject masters, save, and close them.



Step 2

Draw instances of the SmartObject masters into the SmartWindow.



Step 3

Add all necessary SmartLinks between SmartObjects. 



During assembly, the PROGRESS Advisor suggests links and creates them for you. However, you can also add and remove SmartLinks with the SmartLinks dialog box. To access this dialog box, choose the Procedure button from the UIB main window. Then choose the SmartLinks button from the Procedure Settings dialog box.

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME







/* ***************  Runtime Attributes and UIB Settings  ************** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW W-Win

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME F-Main

                                                                        */

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(W-Win)

THEN W-Win:HIDDEN = yes.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB W-Win 

/* ************************* Included-Libraries *********************** */



{src/adm/method/containr.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME W-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL W-Win W-Win

ON END-ERROR OF W-Win /* <insert SmartWindow title> */

OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:

  /* This case occurs when the user presses the "Esc" key.

     In a persistently run window, just ignore this.  If we did not, the

     application would exit. */

  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL W-Win W-Win

ON WINDOW-CLOSE OF W-Win /* <insert SmartWindow title> */

DO:

  /* This ADM code must be left here in order for the SmartWindow

     and its descendents to terminate properly on exit. */

  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK W-Win 





/* ***************************  Main Block  *************************** */



/* Include custom  Main Block code for SmartWindows. */

{src/adm/template/windowmn.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects W-Win _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-row-available W-Win _ADM-ROW-AVAILABLE

PROCEDURE adm-row-available :

/*------------------------------------------------------------------------------

  Purpose:     Dispatched to this procedure when the Record-

               Source has a new row available.  This procedure

               tries to get the new row (or foriegn keys) from

               the Record-Source and process it.

  Parameters:  <none>

------------------------------------------------------------------------------*/



  /* Define variables needed by this internal procedure.             */

  {src/adm/template/row-head.i}



  /* Process the newly available records (i.e. display fields,

     open queries, and/or pass records on to any RECORD-TARGETS).    */

  {src/adm/template/row-end.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI W-Win _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Delete the WINDOW we created */

  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(W-Win)

  THEN DELETE WIDGET W-Win.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI W-Win _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  VIEW FRAME F-Main IN WINDOW W-Win.

  {&OPEN-BROWSERS-IN-QUERY-F-Main}

  VIEW W-Win.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-exit W-Win 

PROCEDURE local-exit :

/* -----------------------------------------------------------

  Purpose:  Starts an "exit" by APPLYing CLOSE event, which starts "destroy".

  Parameters:  <none>

  Notes:    If activated, should APPLY CLOSE, *not* dispatch adm-exit.   

-------------------------------------------------------------*/

   APPLY "CLOSE":U TO THIS-PROCEDURE.

   

   RETURN.

       

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE send-records W-Win _ADM-SEND-RECORDS

PROCEDURE send-records :

/*------------------------------------------------------------------------------

  Purpose:     Send record ROWID's for all tables used by

               this file.

  Parameters:  see template/snd-head.i

------------------------------------------------------------------------------*/



  /* SEND-RECORDS does nothing because there are no External

     Tables specified for this SmartWindow, and there are no

     tables specified in any contained Browse, Query, or Frame. */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE state-changed W-Win 

PROCEDURE state-changed :

/* -----------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

-------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p-issuer-hdl AS HANDLE NO-UNDO.

  DEFINE INPUT PARAMETER p-state AS CHARACTER NO-UNDO.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





