/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* row-head.i - */

  DEFINE VARIABLE tbl-list           AS CHARACTER INIT "":U NO-UNDO.

  DEFINE VARIABLE rowid-list         AS CHARACTER NO-UNDO.

  DEFINE VARIABLE row-avail-cntr     AS INTEGER INIT 0 NO-UNDO.

  DEFINE VARIABLE row-avail-rowid    AS ROWID NO-UNDO.

  DEFINE VARIABLE row-avail-enabled  AS LOGICAL NO-UNDO.

  DEFINE VARIABLE link-handle        AS CHARACTER NO-UNDO.

  DEFINE VARIABLE record-source-hdl  AS HANDLE NO-UNDO.

  DEFINE VARIABLE different-row      AS LOGICAL NO-UNDO INIT no.

  DEFINE VARIABLE key-name           AS CHARACTER INIT ? NO-UNDO.

  DEFINE VARIABLE key-value          AS CHARACTER INIT ? NO-UNDO.

 

  /* Check that the previous record hasn't been modifed. */

  RUN check-modified IN THIS-PROCEDURE ('check':U) NO-ERROR.

  

  /* If nothing's been modified but we're in an update, then the record

     we're getting is the same one we're just finishing up with

     (update-complete state after an Add, for instance). So ignore it. */

  IF adm-updating-record THEN RETURN.



  RUN get-attribute ('FIELDS-ENABLED':U).

  row-avail-enabled = IF RETURN-VALUE = "YES":U THEN yes ELSE no.  

  

  RUN get-link-handle IN adm-broker-hdl (THIS-PROCEDURE, 'RECORD-SOURCE':U,

      OUTPUT link-handle) NO-ERROR.

  IF link-handle = "":U THEN     /* There's no active record source */

      RETURN.

  ASSIGN record-source-hdl = WIDGET-HANDLE(ENTRY(1,link-handle)).

  IF NUM-ENTRIES(link-handle) > 1 THEN  /* A list indicates multiple sources */

      MESSAGE "row-available in ":U THIS-PROCEDURE:FILE-NAME 

          "encountered more than one RECORD-SOURCE.":U SKIP

          "The first - ":U record-source-hdl:file-name " - will be used.":U

             VIEW-AS ALERT-BOX ERROR.

  

  /* Get the key needed by this Record-Target. */         

  RUN get-attribute ('Key-Name':U).

  key-name = RETURN-VALUE.

  IF key-name = "":U THEN key-name = ?.  /* Allow for blank defined value. */

  IF key-name NE ? THEN DO:

    RUN send-key IN record-source-hdl (INPUT key-name, OUTPUT key-value)

      NO-ERROR.

    IF key-value NE ? THEN  /* At design time this won't succeed, so skip it. */

      RUN set-attribute-list (SUBSTITUTE ('Key-Value="&1"':U, key-value)).

  END.

