&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS sObject 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: dynlookup.w 



  Description: from FIELD.W - Template for ADM2 SmartDataField object



  Created: Astra2 Object - November 2000 -- Progress Version 9.1B

           Uses new Astra2 lookup class



    Modified    : 30/07/2001      Mark Davies

                  Frame should not be movable in run-time.

------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



&IF "{&xcInstanceProperties}":U NE "":U &THEN

    &GLOB xcInstanceProperties {&xcInstanceProperties},

  &ENDIF



  &IF "{&xcTranslatableProperties}":U NE "":U &THEN

    &GLOB xcTranslatableProperties {&xcTranslatableProperties},

  &ENDIF

  &GLOB xcTranslatableProperties {&xcTranslatableProperties}~

SelectionLabel,OptionalString



&IF DEFINED (ADM-PROPERTY-DLG) = 0 &THEN

  &SCOP ADM-PROPERTY-DLG ry/uib/rylookupd.w

&ENDIF

/* tell smart.i that we can use the default destroyObject */ 

&SCOPED-DEFINE include-destroyobject

{src/adm2/ttlookup.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDataField

&Scoped-define DB-AWARE no



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME frLookup



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME frLookup

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1

         SIZE 50 BY 1.





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDataField

   Allow: Basic

   Frames: 1

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW sObject ASSIGN

         HEIGHT             = 1

         WIDTH              = 50.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB sObject 

/* ************************* Included-Libraries *********************** */



{src/adm2/lookup.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW sObject

  VISIBLE,,RUN-PERSISTENT                                               */

/* SETTINGS FOR FRAME frLookup

   NOT-VISIBLE Size-to-Fit                                              */

ASSIGN 

       FRAME frLookup:SCROLLABLE       = FALSE

       FRAME frLookup:HIDDEN           = TRUE

       FRAME frLookup:SELECTABLE       = TRUE

       FRAME frLookup:MOVABLE          = TRUE

       FRAME frLookup:RESIZABLE        = TRUE

       FRAME frLookup:PRIVATE-DATA     = 

                "nolookups".



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME frLookup

/* Query rebuild information for FRAME frLookup

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME frLookup */

&ANALYZE-RESUME



 







/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME frLookup

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL frLookup sObject

ON SELECTION OF FRAME frLookup

DO:

  DEFINE VARIABLE cMode AS CHARACTER  NO-UNDO.

  

  {get UIBMode cMode}.

  IF cMode = "":U THEN /* Run Time */

    RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL frLookup sObject

ON START-MOVE OF FRAME frLookup

DO:

  DEFINE VARIABLE cMode AS CHARACTER  NO-UNDO.

  

  {get UIBMode cMode}.

  IF cMode = "":U THEN /* Run Time */

    RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK sObject 





/* ***************************  Main Block  *************************** */



/* If testing in the UIB, initialize the SmartObject. */  

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

  RUN initializeObject.

&ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI sObject  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME frLookup.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject sObject 

PROCEDURE initializeObject :

/*------------------------------------------------------------------------------

  Purpose: Override of initializeObject in order to subscribe to 

           the ChangedEvent if defined and initializeSelection      

  Parameters:  <none>

  Notes:   This is in here rather than the super procedure as when put

           in lookup.p it did not work and the target-procedure in the

           subscribed procedures was wrong.

---------------------------------------------------------------------------*/



  DEFINE VARIABLE cUIBMode              AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE hContainer            AS HANDLE     NO-UNDO.



  {get ContainerSource hContainer}. /* SDV */    

  {get UIBMode cUIBMode}.    

  

  /* subscribe ib containing viewer to events that will populate the combo */

  IF NOT (cUIBMode BEGINS "DESIGN":U)  THEN

  DO:

    SUBSCRIBE TO "getLookupQuery":U IN hContainer.  /* add to lookup tt */

    SUBSCRIBE TO "displayLookup":U IN hContainer.   /* display lookup fields */

  END.



  RUN SUPER.



  RUN initializeLookup IN TARGET-PROCEDURE.



  RETURN.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



