&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

&ANALYZE-RESUME

/* Connected Databases 

*/

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS bTableWin 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: adm2\src\browser.w



  Description: SmartDataBrowser Object



  Input Parameters:

      <none>



  Output Parameters:

      <none>



------------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDataBrowser

&Scoped-define DB-AWARE no



&Scoped-define ADM-SUPPORTED-LINKS TableIO-Target,Data-Target,Update-Source



/* Include file with RowObject temp-table definition */

&Scoped-define DATA-FIELD-DEFS "adm2/support/drouter.i"



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME F-Main

&Scoped-define BROWSE-NAME br_table



/* Internal Tables (found by Frame, Query & Browse Queries)             */

&Scoped-define INTERNAL-TABLES rowObject



/* Definitions for BROWSE br_table                                      */

&Scoped-define FIELDS-IN-QUERY-br_table rowObject.externalref ~

rowObject.internalref 

&Scoped-define ENABLED-FIELDS-IN-QUERY-br_table rowObject.externalref ~

rowObject.internalref 

&Scoped-define ENABLED-TABLES-IN-QUERY-br_table rowObject

&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-br_table rowObject

&Scoped-define OPEN-QUERY-br_table OPEN QUERY br_table FOR EACH rowObject NO-LOCK INDEXED-REPOSITION.

&Scoped-define TABLES-IN-QUERY-br_table rowObject

&Scoped-define FIRST-TABLE-IN-QUERY-br_table rowObject





/* Definitions for FRAME F-Main                                         */



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS br_table 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */

/* Query definitions                                                    */

&ANALYZE-SUSPEND

DEFINE TEMP-TABLE RowObject

    {{&DATA-FIELD-DEFS}}

    {src/adm2/robjflds.i}.



DEFINE QUERY br_table FOR 

      rowObject SCROLLING.

&ANALYZE-RESUME



/* Browse definitions                                                   */

DEFINE BROWSE br_table

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS br_table bTableWin _STRUCTURED

  QUERY br_table NO-LOCK DISPLAY

      rowObject.externalref FORMAT "x(256)":U WIDTH 55

      rowObject.internalref FORMAT "X(256)":U WIDTH 45

  ENABLE

      rowObject.externalref HELP "?"

      rowObject.internalref HELP "?"

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME

    WITH NO-ASSIGN NO-AUTO-VALIDATE NO-ROW-MARKERS SEPARATORS SIZE 100 BY 9.29 EXPANDABLE.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME F-Main

     br_table AT ROW 1 COL 1

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDataBrowser

   Data Source: "adm2/support/drouter.w"

   Allow: Basic,Browse

   Frames: 1

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW bTableWin ASSIGN

         HEIGHT             = 9.29

         WIDTH              = 103.8.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB bTableWin 

/* ************************* Included-Libraries *********************** */



{src/adm2/browser.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW bTableWin

  NOT-VISIBLE,,RUN-PERSISTENT                                           */

/* SETTINGS FOR FRAME F-Main

   NOT-VISIBLE Size-to-Fit                                              */

/* BROWSE-TAB br_table 1 F-Main */

ASSIGN 

       FRAME F-Main:SCROLLABLE       = FALSE

       FRAME F-Main:HIDDEN           = TRUE.



ASSIGN 

       br_table:NUM-LOCKED-COLUMNS IN FRAME F-Main     = 2.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE br_table

/* Query rebuild information for BROWSE br_table

     _TblList          = "rowObject"

     _Options          = "NO-LOCK INDEXED-REPOSITION"

     _FldNameList[1]   > _<SDO>.rowObject.externalref

"rowObject.externalref" ? ? "character" ? ? ? ? ? ? yes "?" no no "55" yes no no "U" "" ""

     _FldNameList[2]   > _<SDO>.rowObject.internalref

"rowObject.internalref" ? ? "character" ? ? ? ? ? ? yes "?" no no "45" yes no no "U" "" ""

     _Query            is NOT OPENED

*/  /* BROWSE br_table */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main

/* Query rebuild information for FRAME F-Main

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME F-Main */

&ANALYZE-RESUME



 







/* ************************  Control Triggers  ************************ */



&Scoped-define BROWSE-NAME br_table

&Scoped-define SELF-NAME br_table

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON CTRL-END OF br_table IN FRAME F-Main

DO:

  APPLY "END":U TO BROWSE br_table.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON CTRL-HOME OF br_table IN FRAME F-Main

DO:

  APPLY "HOME":U TO BROWSE br_table.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON END OF br_table IN FRAME F-Main

DO:

  {src/adm2/brsend.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON HOME OF br_table IN FRAME F-Main

DO:

  {src/adm2/brshome.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON OFF-END OF br_table IN FRAME F-Main

DO:

  {src/adm2/brsoffnd.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON OFF-HOME OF br_table IN FRAME F-Main

DO:

  {src/adm2/brsoffhm.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON ROW-ENTRY OF br_table IN FRAME F-Main

DO:

  {src/adm2/brsentry.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON ROW-LEAVE OF br_table IN FRAME F-Main

DO:

  {src/adm2/brsleave.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON SCROLL-NOTIFY OF br_table IN FRAME F-Main

DO:

  {src/adm2/brsscrol.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br_table bTableWin

ON VALUE-CHANGED OF br_table IN FRAME F-Main

DO:

  {src/adm2/brschnge.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK bTableWin 





/* ***************************  Main Block  *************************** */



&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

RUN initializeObject.        

&ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI bTableWin  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME F-Main.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject bTableWin 

PROCEDURE initializeObject :

/*------------------------------------------------------------------------------

  Purpose:     Super Override

  Parameters:  

  Notes:       

------------------------------------------------------------------------------*/



  /* Code placed here will execute PRIOR to standard behavior. */

  RUN setDown (INPUT 10).



  RUN SUPER.



  /* Code placed here will execute AFTER standard behavior.    */



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



