&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12

/* Procedure Description

"Data Logic Procedure Template

 

Use this template to create  a Data Logic Procedure."

*/

&ANALYZE-RESUME

{adecomm/appserv.i}

DEFINE VARIABLE h_Astra                    AS HANDLE          NO-UNDO.

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" DataLogicProcedure _INLINE

/* Actions: af/cod/aftemwizcw.w ? ? ? ? */

/* MIP Update Version Notes Wizard

Check object version notes.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" DataLogicProcedure _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" DataLogicProcedure _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS DataLogicProcedure 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: gsmuslog2p.p

 

  Description:  gsm_user Data Logic Procedure Library Template

 

  Purpose:      A procedure library (PLIP) to support the maintenance of the gsm_user table

                The following internal procedures may be added or modified

                to act as validation to creation, modification, or deletion of

                records in the database table

 

                Client-side:

                rowObjectValidate***

 

                Server-side upon create:

                createPreTransValidate***

                createBeginTransValidate

                createEndTransValidate

                createPostTransValidate

 

                Server-side upon write (create and modify):

                writePreTransValidate***

                writeBeginTransValidate

                writeEndTransValidate

                writePostTransValidate

 

                Server-side upon delete:

                deletePreTransValidate

                deleteBeginTransValidate

                deleteEndTransValidate

                deletePostTransValidate

 

                *** The rowObjectValidate, createPreTransValidate and writePreTransValidate

                internal procedures are automatically generated by the SDO generator

 

  Parameters:

 

  History:

  --------

  (v:010000)    Task:   101000047   UserRef:    

                Date:   09/28/2001  Author:     Johan Meyer

 

  Update Notes: Added function isFieldBlank to template of SDO Logic Procedure

 

  (v:010001)    Task:    90000119   UserRef:    posse

                Date:   06/05/2001  Author:     Haavard Danielsen

 

  Update Notes: Point to src/adm2/logic.i

 

---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/

 

/* ***************************  Definitions  ************************** */

/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */

 

&scop object-name       gsmuslog2p.p

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    000000

 

/* object identifying preprocessor */

&glob   AstraPlip    yes

 

DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.

 

ASSIGN cObjectName = "{&object-name}":U.

 

&scop   mip-notify-user-on-plip-close   NO

 

 

/* Data Preprocessor Definitions */

&GLOB DATA-LOGIC-TABLE gsm_user

&GLOB DATA-FIELD-DEFS  "af/obj2/secgrpfullo.i"

 

/* Error handling definitions */

{checkerr.i &define-only = YES}



DEFINE TEMP-TABLE ttOrganisation

FIELD  organisation_obj  AS DECIMAL.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE DataLogicProcedure

&Scoped-define DB-AWARE yes





/* Db-Required definitions. */

&IF DEFINED(DB-REQUIRED) = 0 &THEN

    &GLOBAL-DEFINE DB-REQUIRED TRUE

&ENDIF

&GLOBAL-DEFINE DB-REQUIRED-START   &IF {&DB-REQUIRED} &THEN

&GLOBAL-DEFINE DB-REQUIRED-END     &ENDIF











/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME





/* ************************  Function Prototypes ********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD isFieldBlank DataLogicProcedure 

FUNCTION isFieldBlank RETURNS LOGICAL

  ( INPUT pcFieldValue AS CHARACTER )  FORWARD.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: DataLogicProcedure

   Allow: 

   Frames: 0

   Add Fields to: Neither

   Other Settings: CODE-ONLY COMPILE APPSERVER DB-AWARE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW DataLogicProcedure ASSIGN

         HEIGHT             = 25.48

         WIDTH              = 55.6.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB DataLogicProcedure 

/* ************************* Included-Libraries *********************** */

 

{src/adm2/logic.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK DataLogicProcedure 





/* ***************************  Main Block  ******************************* */

 

{ry/app/ryplipmain.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



{&DB-REQUIRED-START}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createPreTransValidate DataLogicProcedure  _DB-REQUIRED

PROCEDURE createPreTransValidate :

/*------------------------------------------------------------------------------

  Purpose:     Procedure used to validate records server-side before the transaction scope upon create

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

 

  DEFINE VARIABLE cMessageList    AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE cValueList      AS CHARACTER    NO-UNDO.

 

 

  ASSIGN

    ERROR-STATUS:ERROR = NO.

  RETURN cMessageList.

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-END}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip DataLogicProcedure 

PROCEDURE killPlip :

/*------------------------------------------------------------------------------

  Purpose:     entry point to instantly kill the plip if it should get lost in memory

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

 

  {ry/app/ryplipkill.i}

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE objectDescription DataLogicProcedure 

PROCEDURE objectDescription :

/*------------------------------------------------------------------------------

  Purpose:     Pass out a description of the PLIP, used in Plip temp-table

  Parameters:  <none>

  Notes:       This should be changed manually for each plip

------------------------------------------------------------------------------*/

 

  DEFINE OUTPUT PARAMETER cDescription AS CHARACTER NO-UNDO.

 

  ASSIGN cDescription = "Template PLIP".

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup DataLogicProcedure 

PROCEDURE plipSetup :

/*------------------------------------------------------------------------------

  Purpose:    Run by main-block of PLIP at startup of PLIP

  Parameters: <none>

  Notes:       

------------------------------------------------------------------------------*/

 

  {ry/app/ryplipsetu.i}  

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown DataLogicProcedure 

PROCEDURE plipShutdown :

/*------------------------------------------------------------------------------

  Purpose:     This procedure will be run just before the calling program 

               terminates

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

 

  {ry/app/ryplipshut.i}

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rowObjectValidate DataLogicProcedure 

PROCEDURE rowObjectValidate :

/*------------------------------------------------------------------------------

  Purpose:     Procedure used to validate RowObject record client-side

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

 

  DEFINE VARIABLE cMessageList    AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE cValueList      AS CHARACTER    NO-UNDO.

 

  IF isFieldBlank(b_gsm_user.user_login_name) THEN

    ASSIGN

      cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                    {aferrortxt.i 'AF' '1' 'gsm_user' 'user_login_name' "'Group name'"}.

 

 

 

  ASSIGN

    ERROR-STATUS:ERROR = NO.

  RETURN cMessageList.

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-START}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE writeBeginTransValidate DataLogicProcedure  _DB-REQUIRED

PROCEDURE writeBeginTransValidate :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  /* This SDO is only used to create Groups */

  IF AVAILABLE b_gsm_user THEN

    ASSIGN b_gsm_user.security_group = TRUE.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-END}



{&DB-REQUIRED-START}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE writeEndTransValidate DataLogicProcedure  _DB-REQUIRED

PROCEDURE writeEndTransValidate :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE VARIABLE cMessageList    AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE cValueList      AS CHARACTER    NO-UNDO.

 

  /*

  DEFINE BUFFER usr_gsm_user            FOR gsm_user.         

  DEFINE BUFFER gsm_user_allocation     FOR gsm_user_allocation.

  DEFINE BUFFER gsm_group_allocation    FOR gsm_group_allocation.

  

  IF (isCreate() AND b_gsm_user.default_security_group = TRUE) OR (b_gsm_user.default_security_group = TRUE AND old_gsm_user.default_security_group = FALSE) THEN

  DO:

    /* create a tt storing all organisations the group is linked to. o for all organisations, else

       the organisations obj */

    IF NOT(CAN-FIND(FIRST gsm_user_allocation NO-LOCK

      WHERE gsm_user_allocation.user_obj               = b_gsm_user.user_obj

        AND gsm_user_allocation.owning_entity_mnemonic = "GSMGA":U)) THEN

    DO:

      CREATE ttOrganisation.

      ASSIGN ttOrganisation.organisation_obj = 0. 

    END.

    ELSE

    FOR EACH gsm_user_allocation NO-LOCK

      WHERE gsm_user_allocation.user_obj               = b_gsm_user.user_obj

        AND gsm_user_allocation.owning_entity_mnemonic = "GSMGA":U:

        

      CREATE ttOrganisation.

      ASSIGN ttOrganisation.organisation_obj = gsm_user_allocation.owning_obj. 

        

    END.

    

    /* go through all users*/

    FOR EACH usr_gsm_user NO-LOCK

      WHERE usr_gsm_user.security_group = FALSE

        AND usr_gsm_user.DISABLED       = FALSE:

      

      /* all organisations that the group is linked to */

      FOR EACH ttOrganisation:

      

        /* create allocation to the default group from the users*/

        IF NOT(CAN-FIND(FIRST gsm_group_allocation NO-LOCK 

          WHERE gsm_group_allocation.user_obj          = usr_gsm_user.user_obj

            AND gsm_group_allocation.group_user_obj    = b_gsm_user.user_obj

            AND gsm_group_allocation.login_company_obj = ttOrganisation.organisation_obj)) THEN

        DO:

        

          CREATE gsm_group_allocation NO-ERROR.

      

          IF RETURN-VALUE <> "":U THEN

            ASSIGN cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) +

                                  RETURN-VALUE.

          ELSE 

          DO:

            ASSIGN gsm_group_allocation.user_obj          = usr_gsm_user.user_obj

                   gsm_group_allocation.group_user_obj    = b_gsm_user.user_obj

                   gsm_group_allocation.login_company_obj = ttOrganisation.organisation_obj

                   NO-ERROR.

      

            VALIDATE gsm_group_allocation NO-ERROR.

         

            IF RETURN-VALUE <> "":U THEN

              ASSIGN cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) +

                                    RETURN-VALUE.          

          END.

        END.

      END.

    END.

  END. 

  */

 

  ASSIGN

    ERROR-STATUS:ERROR = NO.

  RETURN cMessageList.





END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-END}



/* ************************  Function Implementations ***************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION isFieldBlank DataLogicProcedure 

FUNCTION isFieldBlank RETURNS LOGICAL

  ( INPUT pcFieldValue AS CHARACTER ) :

/*------------------------------------------------------------------------------

  Purpose:  Checks whether a character field is blank

    Notes:  

------------------------------------------------------------------------------*/

 

  IF LENGTH(TRIM(pcFieldValue)) = 0 OR LENGTH(TRIM(pcFieldValue)) = ? THEN

    RETURN TRUE.

  ELSE

    RETURN FALSE.   /* Function return value. */

 

END FUNCTION.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



