&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12

&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE

/* Actions: af/cod/aftemwizcw.w ? ? ? ? */

/* MIP Update Version Notes Wizard

Check object version notes.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: afgetfldlp.p



  Description:  Get table field list



  Purpose:      Returns a comma-delimited list of field names for a given DB.TABLE

                A database alias of db_metaschema must already be available



  Parameters:   INPUT  ip_tblname:    table name

                OUTPUT op_fldname:   comma-delimited list of fields



  History:

  --------

  (v:010000)    Task:         212   UserRef:    sm

                Date:   15/06/1998  Author:     Sean Enraght-Moony



  Update Notes: Created from Template aftemprocp.p

                Created from Template afgetfldlp.p



---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/



/* ***************************  Definitions  ************************** */

/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       afgetfldlp.p

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    010000





/* MIP object identifying preprocessor */

&glob   mip-structured-procedure    yes



DEFINE INPUT  PARAMETER ip_tblname AS CHARACTER NO-UNDO.

DEFINE OUTPUT PARAMETER op_fldname AS CHARACTER NO-UNDO.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE Procedure







/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: Procedure

   Allow: 

   Frames: 0

   Add Fields to: Neither

   Other Settings: CODE-ONLY COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW Procedure ASSIGN

         HEIGHT             = 1.95

         WIDTH              = 40.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME









&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 





/* ***************************  Main Block  *************************** */



ASSIGN op_fldname = ?.

FIND FIRST db_metaschema._file NO-LOCK

     WHERE db_metaschema._file._file-name = ip_tblname /*NO-ERROR*/.

IF AVAILABLE db_metaschema._file THEN

  DO:

    FOR EACH db_metaschema._field OF db_metaschema._file NO-LOCK:

        ASSIGN op_fldname = (IF op_fldname = ? THEN "" ELSE op_fldname + ",") + db_metaschema._field._field-name.

    END.

  END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





