/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: afsessnidp.p



  Description:  Session Id Procedure



  Purpose:      To allocate a unique session id using the sequence

                seq_session_id.

                This is used when running client side with no Appserver

                connection to replace the server-connection-id.



  Parameters:   output session id



  History:

  --------

  (v:010000)    Task:        5653   UserRef:    

                Date:   30/05/2000  Author:     Anthony Swindells



  Update Notes: Created from Template aftemplipp.p



---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/



DEFINE OUTPUT PARAMETER pcSessionId AS CHARACTER NO-UNDO.



IF CONNECTED("RVDB") THEN

  RUN rv/app/rvsessnidp.p (OUTPUT pcSessionId).

ELSE

  RUN ry/app/rysessnidp.p (OUTPUT pcSessionId).

