/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors: MIP Holdings (Pty) Ltd ("MIP")                       *

*               PSC                                                  *

*                                                                    *

*********************************************************************/



TRIGGER PROCEDURE FOR CREATE OF gsc_object_type .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gsc_object_type           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gsc_object_type

&SCOPED-DEFINE TRIGGER_FLA gscot

&SCOPED-DEFINE TRIGGER_OBJ object_type_obj





DEFINE BUFFER lb_table FOR gsc_object_type.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gsc_object_type.     /* Used for lock upgrades */



DEFINE BUFFER o_gsc_object_type FOR gsc_object_type.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* ryc_smartobject is the class procedure for gsc_object_type ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST ryc_smartobject WHERE

    gsc_object_type.class_smartobject_obj = ryc_smartobject.smartobject_obj)) THEN

  DO:

    

    ASSIGN gsc_object_type.class_smartobject_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* gsc_object_type is extended by gsc_object_type ON CHILD INSERT SET NULL */



IF NOT(CAN-FIND(FIRST lb_table WHERE

    gsc_object_type.extends_object_type_obj = lb_table.object_type_obj)) THEN

  DO:

    

    ASSIGN gsc_object_type.extends_object_type_obj = 0 .

  END.















ASSIGN gsc_object_type.{&TRIGGER_OBJ} = getNextObj() NO-ERROR.

IF ERROR-STATUS:ERROR THEN 

DO:

    ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 31 lv-include = "gsc_object_type|the specified object number.  Please ensure your database sequences have been set correctly":U.

    RUN error-message (lv-errgrp, lv-errnum, lv-include).

END.















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gscot':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "gscot":U, INPUT BUFFER gsc_object_type:HANDLE, INPUT BUFFER o_gsc_object_type:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

