/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors: MIP Holdings (Pty) Ltd ("MIP")                       *

*               PSC                                                  *

*                                                                    *

*********************************************************************/



TRIGGER PROCEDURE FOR WRITE OF gsm_menu_structure_item OLD BUFFER o_gsm_menu_structure_item.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gsm_menu_structure_item           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gsm_menu_structure_item

&SCOPED-DEFINE TRIGGER_FLA gsmit

&SCOPED-DEFINE TRIGGER_OBJ menu_structure_item_obj





DEFINE BUFFER lb_table FOR gsm_menu_structure_item.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gsm_menu_structure_item.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gsmit':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER gsm_menu_structure_item:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gsm_menu_item may contain gsm_menu_structure_item ON CHILD UPDATE SET NULL */

IF NEW gsm_menu_structure_item OR  gsm_menu_structure_item.menu_item_obj <> o_gsm_menu_structure_item.menu_item_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gsm_menu_item WHERE

        gsm_menu_structure_item.menu_item_obj = gsm_menu_item.menu_item_obj)) THEN DO:

        

        ASSIGN gsm_menu_structure_item.menu_item_obj = 0 .

    END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* gsm_menu_structure is the child of gsm_menu_structure_item ON CHILD UPDATE SET NULL */

IF NEW gsm_menu_structure_item OR  gsm_menu_structure_item.child_menu_structure_obj <> o_gsm_menu_structure_item.child_menu_structure_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gsm_menu_structure WHERE

        gsm_menu_structure_item.child_menu_structure_obj = gsm_menu_structure.menu_structure_obj)) THEN DO:

        

        ASSIGN gsm_menu_structure_item.child_menu_structure_obj = 0 .

    END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* gsm_menu_structure contains gsm_menu_structure_item ON CHILD UPDATE RESTRICT */

IF NEW gsm_menu_structure_item OR  gsm_menu_structure_item.menu_structure_obj <> o_gsm_menu_structure_item.menu_structure_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gsm_menu_structure WHERE

        gsm_menu_structure_item.menu_structure_obj = gsm_menu_structure.menu_structure_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "gsm_menu_structure_item|gsm_menu_structure":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW gsm_menu_structure_item AND gsm_menu_structure_item.{&TRIGGER_OBJ} <> o_gsm_menu_structure_item.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{icf/trg/gsmittrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gsmit':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "gsmit":U, INPUT BUFFER gsm_menu_structure_item:HANDLE, INPUT BUFFER o_gsm_menu_structure_item:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







