/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors: MIP Holdings (Pty) Ltd ("MIP")                       *

*               PSC                                                  *

*                                                                    *

*********************************************************************/



TRIGGER PROCEDURE FOR CREATE OF ryc_attribute_value .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   ryc_attribute_value           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE ryc_attribute_value

&SCOPED-DEFINE TRIGGER_FLA rycav

&SCOPED-DEFINE TRIGGER_OBJ attribute_value_obj





DEFINE BUFFER lb_table FOR ryc_attribute_value.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR ryc_attribute_value.     /* Used for lock upgrades */



DEFINE BUFFER o_ryc_attribute_value FOR ryc_attribute_value.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* ryc_render_type has ryc_attribute_value ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST ryc_render_type WHERE

    ryc_attribute_value.render_type_obj = ryc_render_type.render_type_obj)) THEN

  DO:

    

    ASSIGN ryc_attribute_value.render_type_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* gsc_object_type has ryc_attribute_value ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST gsc_object_type WHERE

    ryc_attribute_value.object_type_obj = gsc_object_type.object_type_obj)) THEN

  DO:

    

    ASSIGN ryc_attribute_value.object_type_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* ryc_object_instance has ryc_attribute_value ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST ryc_object_instance WHERE

    ryc_attribute_value.object_instance_obj = ryc_object_instance.object_instance_obj)) THEN

  DO:

    

    ASSIGN ryc_attribute_value.object_instance_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* ryc_smartobject has ryc_attribute_value ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST ryc_smartobject WHERE

    ryc_attribute_value.smartobject_obj = ryc_smartobject.smartobject_obj)) THEN

  DO:

    

    ASSIGN ryc_attribute_value.smartobject_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* ryc_attribute has ryc_attribute_value ON CHILD INSERT RESTRICT */

IF 

    ( ryc_attribute_value.attribute_label <> "":U ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST ryc_attribute WHERE

        ryc_attribute_value.attribute_label = ryc_attribute.attribute_label)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "ryc_attribute_value|ryc_attribute":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN ryc_attribute_value.{&TRIGGER_OBJ} = getNextObj() NO-ERROR.

IF ERROR-STATUS:ERROR THEN 

DO:

    ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 31 lv-include = "ryc_attribute_value|the specified object number.  Please ensure your database sequences have been set correctly":U.

    RUN error-message (lv-errgrp, lv-errnum, lv-include).

END.















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'rycav':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "rycav":U, INPUT BUFFER ryc_attribute_value:HANDLE, INPUT BUFFER o_ryc_attribute_value:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */





