&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12

/* Procedure Description

"Data Logic Procedure Template



Use this template to create  a Data Logic Procedure."

*/

&ANALYZE-RESUME

{adecomm/appserv.i}

DEFINE VARIABLE h_Astra                    AS HANDLE          NO-UNDO.

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" DataLogicProcedure _INLINE

/* Actions: af/cod/aftemwizcw.w ? ? ? ? */

/* MIP Update Version Notes Wizard

Check object version notes.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" DataLogicProcedure _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" DataLogicProcedure _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS DataLogicProcedure 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: rytemlogic.p



  Description:  ryc_attribute Data Logic Procedure Library Template



  Purpose:      A procedure library (PLIP) to support the maintenance of the ryc_attribute table

                The following internal procedures may be added or modified

                to act as validation to creation, modification, or deletion of

                records in the database table

                

                Client-side:

                rowObjectValidate***

                

                Server-side upon create:

                createPreTransValidate***

                createBeginTransValidate

                createEndTransValidate

                createPostTransValidate

                

                Server-side upon write (create and modify):

                writePreTransValidate***

                writeBeginTransValidate

                writeEndTransValidate

                writePostTransValidate

                

                Server-side upon delete:

                deletePreTransValidate

                deleteBeginTransValidate

                deleteEndTransValidate

                deletePostTransValidate

                

                *** The rowObjectValidate, createPreTransValidate and writePreTransValidate

                internal procedures are automatically generated by the SDO generator



  Parameters:



  History:

  --------

  (v:010000)    Task:   101000047   UserRef:    

                Date:   09/28/2001  Author:     Johan Meyer



  Update Notes: Added function isFieldBlank to template of SDO Logic Procedure



  (v:010001)    Task:    90000119   UserRef:    posse

                Date:   06/05/2001  Author:     Haavard Danielsen



  Update Notes: Point to src/adm2/logic.i



---------------------------------------------------------------------------------*/

/*                   This .W file was created with the Progress UIB.             */

/*-------------------------------------------------------------------------------*/



/* ***************************  Definitions  ************************** */

/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       rycatlogcp.p

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    000000



/* object identifying preprocessor */

&glob   AstraPlip    yes



DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.



ASSIGN cObjectName = "{&object-name}":U.



&scop   mip-notify-user-on-plip-close   NO





/* Data Preprocessor Definitions */

&GLOB DATA-LOGIC-TABLE ryc_attribute

&GLOB DATA-FIELD-DEFS  "ry/obj/rycatfullo.i"



/* Error handling definitions */

{checkerr.i &define-only = YES}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE DataLogicProcedure

&Scoped-define DB-AWARE yes





/* Db-Required definitions. */

&IF DEFINED(DB-REQUIRED) = 0 &THEN

    &GLOBAL-DEFINE DB-REQUIRED TRUE

&ENDIF

&GLOBAL-DEFINE DB-REQUIRED-START   &IF {&DB-REQUIRED} &THEN

&GLOBAL-DEFINE DB-REQUIRED-END     &ENDIF







/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME





/* ************************  Function Prototypes ********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD isFieldBlank DataLogicProcedure 

FUNCTION isFieldBlank RETURNS LOGICAL

  ( INPUT pcFieldValue AS CHARACTER )  FORWARD.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: DataLogicProcedure

   Allow: 

   Frames: 0

   Add Fields to: Neither

   Other Settings: CODE-ONLY COMPILE APPSERVER DB-AWARE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW DataLogicProcedure ASSIGN

         HEIGHT             = 8.43

         WIDTH              = 55.6.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB DataLogicProcedure 

/* ************************* Included-Libraries *********************** */



{src/adm2/logic.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





 





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK DataLogicProcedure 





/* ***************************  Main Block  ******************************* */



{ry/app/ryplipmain.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



{&DB-REQUIRED-START}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createPreTransValidate DataLogicProcedure  _DB-REQUIRED

PROCEDURE createPreTransValidate :

/*------------------------------------------------------------------------------

  Purpose:     Procedure used to validate records server-side before the transaction scope upon create

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE VARIABLE cMessageList    AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE cValueList      AS CHARACTER    NO-UNDO.



  IF CAN-FIND(FIRST ryc_attribute 

              WHERE ryc_attribute.attribute_group_obj = b_ryc_attribute.attribute_group_obj

                AND ryc_attribute.attribute_label = b_ryc_attribute.attribute_label) THEN

  DO:

     ASSIGN

        cValueList   = STRING(b_ryc_attribute.attribute_group_obj) + ', ' + STRING(b_ryc_attribute.attribute_label)

        cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                      {aferrortxt.i 'AF' '8' 'ryc_attribute' '' "'attribute_group_obj, attribute_label, '" cValueList }.

  END.





  IF CAN-FIND(FIRST ryc_attribute 

              WHERE ryc_attribute.attribute_label = b_ryc_attribute.attribute_label) THEN

  DO:

     ASSIGN

        cValueList   = STRING(b_ryc_attribute.attribute_label)

        cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                      {aferrortxt.i 'AF' '8' 'ryc_attribute' '' "'attribute_label, '" cValueList }.

  END.



  ERROR-STATUS:ERROR = NO.

  RETURN cMessageList.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-END}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip DataLogicProcedure 

PROCEDURE killPlip :

/*------------------------------------------------------------------------------

  Purpose:     entry point to instantly kill the plip if it should get lost in memory

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  {ry/app/ryplipkill.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-START}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE modifyNewRecord DataLogicProcedure  _DB-REQUIRED

PROCEDURE modifyNewRecord :

/*------------------------------------------------------------------------------

  Purpose:  Hook into add/copy to ensure default data-type is character                

  Parameters:  <none>

  Notes:    This is a workaround for the fact that the initial value is

            0 in the db and we are using combo-box on the client.   

------------------------------------------------------------------------------*/

   IF isAdd() THEN

     ASSIGN  /* integer 1 = character  */

        b_ryc_attribute.data_type = 1.

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-END}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE objectDescription DataLogicProcedure 

PROCEDURE objectDescription :

/*------------------------------------------------------------------------------

  Purpose:     Pass out a description of the PLIP, used in Plip temp-table

  Parameters:  <none>

  Notes:       This should be changed manually for each plip

------------------------------------------------------------------------------*/



  DEFINE OUTPUT PARAMETER cDescription AS CHARACTER NO-UNDO.



  ASSIGN cDescription = "ryc_attribute Data Logic Procedure".



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup DataLogicProcedure 

PROCEDURE plipSetup :

/*------------------------------------------------------------------------------

  Purpose:    Run by main-block of PLIP at startup of PLIP

  Parameters: <none>

  Notes:       

------------------------------------------------------------------------------*/



  {ry/app/ryplipsetu.i}  



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown DataLogicProcedure 

PROCEDURE plipShutdown :

/*------------------------------------------------------------------------------

  Purpose:     This procedure will be run just before the calling program 

               terminates

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  {ry/app/ryplipshut.i}



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rowObjectValidate DataLogicProcedure 

PROCEDURE rowObjectValidate :

/*------------------------------------------------------------------------------

  Purpose:     Procedure used to validate RowObject record client-side

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE VARIABLE cMessageList    AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE cValueList      AS CHARACTER    NO-UNDO.



  IF b_ryc_attribute.attribute_group_obj = 0 OR b_ryc_attribute.attribute_group_obj = ? THEN

    ASSIGN

      cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                    {aferrortxt.i 'AF' '1' 'ryc_attribute' 'attribute_group_obj' "'Attribute Group Obj'"}.



  IF isFieldBlank(b_ryc_attribute.attribute_label) THEN

    ASSIGN

      cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                    {aferrortxt.i 'AF' '1' 'ryc_attribute' 'attribute_label' "'Attribute Label'"}.



  ERROR-STATUS:ERROR = NO.

  RETURN cMessageList.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-START}



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE writePreTransValidate DataLogicProcedure  _DB-REQUIRED

PROCEDURE writePreTransValidate :

/*------------------------------------------------------------------------------

  Purpose:     Procedure used to validate records server-side before the transaction scope upon write

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/



  DEFINE VARIABLE cMessageList    AS CHARACTER    NO-UNDO.

  DEFINE VARIABLE cValueList      AS CHARACTER    NO-UNDO.



  IF NOT isCreate() AND CAN-FIND(FIRST ryc_attribute 

              WHERE ryc_attribute.attribute_group_obj = b_ryc_attribute.attribute_group_obj

                AND ryc_attribute.attribute_label = b_ryc_attribute.attribute_label

                AND ROWID(ryc_attribute) <> TO-ROWID(ENTRY(1,b_ryc_attribute.RowIDent))) THEN

  DO:

     ASSIGN

        cValueList   = STRING(b_ryc_attribute.attribute_group_obj) + ', ' + STRING(b_ryc_attribute.attribute_label)

        cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                      {aferrortxt.i 'AF' '8' 'ryc_attribute' '' "'attribute_group_obj, attribute_label, '" cValueList }.

  END.





  IF NOT isCreate() AND CAN-FIND(FIRST ryc_attribute 

              WHERE ryc_attribute.attribute_label = b_ryc_attribute.attribute_label

                AND ROWID(ryc_attribute) <> TO-ROWID(ENTRY(1,b_ryc_attribute.RowIDent))) THEN

  DO:

     ASSIGN

        cValueList   = STRING(b_ryc_attribute.attribute_label)

        cMessageList = cMessageList + (IF NUM-ENTRIES(cMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) + 

                      {aferrortxt.i 'AF' '8' 'ryc_attribute' '' "'attribute_label, '" cValueList }.

  END.



  ERROR-STATUS:ERROR = NO.

  RETURN cMessageList.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



{&DB-REQUIRED-END}



/* ************************  Function Implementations ***************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION isFieldBlank DataLogicProcedure 

FUNCTION isFieldBlank RETURNS LOGICAL

  ( INPUT pcFieldValue AS CHARACTER ) :

/*------------------------------------------------------------------------------

  Purpose:  Checks whether a character field is blank

    Notes:  

------------------------------------------------------------------------------*/



  IF LENGTH(TRIM(pcFieldValue)) = 0 OR LENGTH(TRIM(pcFieldValue)) = ? THEN

    RETURN TRUE.

  ELSE

    RETURN FALSE.   /* Function return value. */



END FUNCTION.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



