&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2

/* Procedure Description

" Dynamic SmartDataBrowser Object Template with Wizard.



Use this template to create a new Dynamic SmartDataBrowser object with the assistance of the Dynamic SmartDataBrowser Wizard. When completed, this object can then be referenced onto any Dynamic Smart container, such as a Dynamic Object Controller or Dynamic Folder."

*/

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" bTableWin _INLINE

/* Actions: ? ? ? ? af/sup/afverxftrp.p */

/* This has to go above the definitions sections, as that is what it modifies.

   If its not, then the definitions section will have been saved before the

   XFTR code kicks in and changes it */

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR " Dynamic SmartDataBrowser Wizard" bTableWin _INLINE

/* Actions: af/cod/aftemwizcw.w ? ? ? af/sup/afwizdeltp.p */

/*  Dynamic SmartDataBrowser Wizard

Welcome to the Dynamic SmartDataBrowser Wizard! During the next few steps, the wizard will lead you through all the stages necessary to create this type of object. If you cancel the wizard at any time, then all your changes will be lost. Once the wizard is completed, it is possible to recall parts of the wizard using the LIST option from the section editor. Press Next to proceed.

af/cod/aftemwiziw.w,af/cod/aftemwizpw.w,af/cod2/aftemwizow.w,adm2/support/_wizdfld.w,af/cod/aftemwizew.w 

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" bTableWin _INLINE

/* Actions: ? af/cod/aftemwizcw.w ? ? ? */

/* Program Definition Comment Block Wizard

Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.

af/cod/aftemwizpw.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS bTableWin 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*---------------------------------------------------------------------------------

  File: fullb



  Description:  Template Dynamic SmartDataBrowser Template



  Purpose:      Template Dynamic SmartDataBrowser Template



  Parameters:   <none>



  History:

  --------

  (v:010000)    Task:        6180   UserRef:    

                Date:   28/06/2000  Author:     Anthony Swindells



  Update Notes: V9 Templates



--------------------------------------------------------------------*/

/*          This .W file was created with the Progress AppBuilder.      */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* MIP-GET-OBJECT-VERSION pre-processors

   The following pre-processors are maintained automatically when the object is

   saved. They pull the object and version from Roundtable if possible so that it

   can be displayed in the about window of the container */



&scop object-name       rydynbrwwizw.w

DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.

&scop object-version    010000



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/*  object identifying preprocessor */

&glob   astra2-DynamicSmartDataBrowser yes



{src/adm2/globals.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE SmartDataBrowser

&Scoped-define DB-AWARE no



&Scoped-define ADM-SUPPORTED-LINKS TableIO-Target,Data-Target,Update-Source



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME frMain

&Scoped-define BROWSE-NAME brTable



/* Definitions for FRAME frMain                                         */



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS brTable 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* Definitions of the field level widgets                               */



/* Browse definitions                                                   */

DEFINE BROWSE brTable

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS brTable bTableWin _STRUCTURED



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME

    WITH NO-ASSIGN NO-AUTO-VALIDATE NO-ROW-MARKERS SEPARATORS SIZE 66 BY 6.67 EXPANDABLE

         CONTEXT-HELP-ID 0.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME frMain

     brTable AT ROW 1 COL 1

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1 SCROLLABLE .





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: SmartDataBrowser Template

   Allow: Basic,Browse

   Frames: 1

   Add Fields to: Neither

   Other Settings: PERSISTENT-ONLY COMPILE

 */



/* This procedure should always be RUN PERSISTENT.  Report the error,  */

/* then cleanup and return.                                            */

IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:

  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U

          VIEW-AS ALERT-BOX ERROR BUTTONS OK.

  RETURN.

END.



&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW bTableWin ASSIGN

         HEIGHT             = 6.86

         WIDTH              = 66.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB bTableWin 

/* ************************* Included-Libraries *********************** */



{src/adm2/browser.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW bTableWin

  NOT-VISIBLE,,RUN-PERSISTENT                                           */

/* SETTINGS FOR FRAME frMain

   NOT-VISIBLE Size-to-Fit                                              */

/* BROWSE-TAB brTable 1 frMain */

ASSIGN 

       BrTable:ALLOW-COLUMN-SEARCHING IN FRAME frMain = TRUE

       BrTable:COLUMN-RESIZABLE IN FRAME frMain       = TRUE

       FRAME frMain:SCROLLABLE       = FALSE

       FRAME frMain:HIDDEN           = TRUE.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE brTable

/* Query rebuild information for BROWSE brTable

     _Options          = "NO-LOCK INDEXED-REPOSITION"

     _Query            is NOT OPENED

*/  /* BROWSE brTable */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME frMain

/* Query rebuild information for FRAME frMain

     _Options          = "NO-LOCK"

     _Query            is NOT OPENED

*/  /* FRAME frMain */

&ANALYZE-RESUME











/* ************************  Control Triggers  ************************ */



&Scoped-define BROWSE-NAME brTable

&Scoped-define SELF-NAME brTable

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON CTRL-END OF brTable IN FRAME frMain

DO:

  APPLY "END":U TO BROWSE brTable.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON CTRL-HOME OF brTable IN FRAME frMain

DO:

  APPLY "HOME":U TO BROWSE brTable.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON END OF brTable IN FRAME frMain

DO:

  {src/adm2/brsend.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON HOME OF brTable IN FRAME frMain

DO:

  {src/adm2/brshome.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON OFF-END OF brTable IN FRAME frMain

DO:

  {src/adm2/brsoffnd.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON OFF-HOME OF brTable IN FRAME frMain

DO:

  {src/adm2/brsoffhm.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON ROW-ENTRY OF brTable IN FRAME frMain

DO:

  {src/adm2/brsentry.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON ROW-LEAVE OF brTable IN FRAME frMain

DO:

  {src/adm2/brsleave.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON SCROLL-NOTIFY OF brTable IN FRAME frMain

DO:

  {src/adm2/brsscrol.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTable bTableWin

ON VALUE-CHANGED OF brTable IN FRAME frMain

DO:

  {src/adm2/brschnge.i}

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK bTableWin 





/* ***************************  Main Block  *************************** */



&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          

RUN initializeObject.        

&ENDIF



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI bTableWin  _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Hide all frames. */

  HIDE FRAME frMain.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



