/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* t-d-swe.p - Swedish language definitions for Data Export module */



{ prores/t-define.i }



DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.



IF qbf-s < 0 THEN RETURN.

qbf-lang = "".



/*--------------------------------------------------------------------------*/

/* d-edit.p,a-edit.p */

IF qbf-s = 1 THEN

/*

When entering codes, the following methods may be used:

  'x' - literal character enclosed in single quotes.

  ^x  - interpreted as control-character.

  ##h - one or two hex digits followed by the letter "h".

  ### - one, two or three digits, a decimal number.

  xxx - "xxx" is a symbol such as "lf" from the following table.

*/

  ASSIGN

    qbf-lang[ 1] = 'r en symbol s som'

    qbf-lang[ 2] = 'frn fljande tabell.'

    qbf-lang[ 3] = 'Tryck [' + KBLABEL("GET")

                 + '] fr att skifta Expertlge  av och p.'

    /* format x(70): */

    qbf-lang[ 4] = 'Nr koder anges, kan dessa metoder anvndas och mixas '

                 + 'fritt:'

    /* format x(60): */

    qbf-lang[ 5] = 'bokstavstecken inneslutet mellan enkelcitattecken.'

    qbf-lang[ 6] = 'tolkat som styrtecken.'

    qbf-lang[ 7] = 'en eller tv hexsiffror fljda av bokstaven "h".'

    qbf-lang[ 8] = 'en, tv eller tre siffror, ett decimaltal.'

    qbf-lang[ 9] = 'r en oknd kod.  Korrigera.'

    qbf-lang[10] = 'Processar definitioner av skrivarstyrningar...'.



ELSE



/*--------------------------------------------------------------------------*/

/* d-main.p */

IF qbf-s = 2 THEN

  ASSIGN

    qbf-lang[ 1] = 'Filer:,     :,     :,     :,     :'

    qbf-lang[ 2] = 'Ordn.:'

    qbf-lang[ 3] = 'Dataexport info'

    qbf-lang[ 4] = 'Dataexport layout'

    qbf-lang[ 5] = 'Flt  :,      :,      :,      :,      :'

    qbf-lang[ 7] = '      Exporttyp:'

    qbf-lang[ 8] = 'Rubriker:'

    qbf-lang[ 9] = '    (export namn som frsta post)'

    qbf-lang[10] = '     Post start:'

    qbf-lang[11] = '     Post  slut:'

    qbf-lang[12] = ' Fltbegrnsare:'

    qbf-lang[13] = ' Flt separator:'

    qbf-lang[14] = 'Dataexport klarar ej export av hel matris (ange de element'

                 + 'du vill exportera). Om du fortstter kommer de att tas '

                 + ' bort frn exporten.^Vill du fortstta?'

    qbf-lang[15] = 'Kan ej exportera data med inga definierade flt.'

    qbf-lang[21] = 'Du rensade inte det aktuella exportformatet.  '

                 + 'Vill du nd fortstta?'

    qbf-lang[22] = 'Genererar exportprogram...'

    qbf-lang[23] = 'Kompilerar exportprogram...'

    qbf-lang[24] = 'Kr genererat program...'

    qbf-lang[25] = 'Kunde ej skriva till fil eller enhet'

    qbf-lang[26] = '~{1~} poster exporterade.'

    qbf-lang[31] = 'Skert att du vill terstlla exportinstllningen?'

    qbf-lang[32] = 'Skert att du vill avsluta denna modul?'.



ELSE



/*--------------------------------------------------------------------------*/

/* d-main.p */

/* this set contains only export formats.  Each is composed of the */

/* internal RESULTS id and the description.  The description must  */

/* not contain a comma, and must fit within format x(32).          */

IF qbf-s = 3 THEN

  ASSIGN

    qbf-lang[ 1] = 'PROGRESS,PROGRESS Export'

    qbf-lang[ 2] = 'ASCII   ,Normal ASCII'

    qbf-lang[ 3] = 'ASCII-H ,ASCII med fltnamnsrubrik'

    qbf-lang[ 4] = 'FIXED   ,Fix bredd ASCII (SDF)'

    qbf-lang[ 5] = 'CSV     ,Komma-separerat vrde (CSV)'

    qbf-lang[ 6] = 'DIF     ,DIF'

    qbf-lang[ 7] = 'SYLK    ,SYLK'

    qbf-lang[ 8] = 'WS      ,WordStar'

    qbf-lang[ 9] = 'WORD    ,Microsoft Word'

    qbf-lang[10] = 'WORD4WIN,Microsoft Word fr Windows'

    qbf-lang[11] = 'WPERF   ,WordPerfect'

    qbf-lang[12] = 'OFISW   ,CTOS/BTOS OfisWriter'

    qbf-lang[13] = 'USER    ,Egen'

    qbf-lang[14] = '*'. /* terminator for list */



/*--------------------------------------------------------------------------*/



RETURN.

