/*********************************************************************


* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *


* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *


* below.  All Rights Reserved.                                       *


*                                                                    *


* The Initial Developer of the Original Code is PSC.  The Original   *


* Code is Progress IDE code released to open source December 1, 2000.*


*                                                                    *


* The contents of this file are subject to the Possenet Public       *


* License Version 1.0 (the "License"); you may not use this file     *


* except in compliance with the License.  A copy of the License is   *


* available as of the date of this notice at                         *


* http://www.possenet.org/license.html                               *


*                                                                    *


* Software distributed under the License is distributed on an "AS IS"*


* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*


* should refer to the License for the specific language governing    *


* rights and limitations under the License.                          *


*                                                                    *


* Contributors:                                                      *


*                                                                    *


*********************************************************************/


/* t-l-eng.p - English language definitions for Labels module */





{ prores/t-define.i }





DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.





IF qbf-s < 0 THEN RETURN.


qbf-lang = "".





/*--------------------------------------------------------------------------*/


/* l-guess.p:1..5,l-verify.p:6.. */


IF qbf-s = 1 THEN


  ASSIGN


    qbf-lang[ 1] = '㫞  "~{1~}"    妬 "~{2~}" ...'


    qbf-lang[ 2] = ' ⟞ ⛠   棘 㫞.'


    qbf-lang[ 4] = '     ⫫'


    qbf-lang[ 5] = ',毞,矬 #1,矬 #2,矬 #3,..,'


                 + '梞,..  梞 ,,騘'





    qbf-lang[ 6] = ' ~{1~}: 姜/⦤ ᚡ.'


    qbf-lang[ 7] = ' ~{2~}:  ⟞   "~{1~}".'


    qbf-lang[ 8] = ' ~{2~}:   "~{1~}",  夘 秦 夘.'


    qbf-lang[ 9] = ' ~{2~}:   "~{1~}", 㟦 - ~{3~} 夜  ⚠ 樠.'


    qbf-lang[10] = ' ~{2~}:   "~{1~}", ⨮  -⤦ .'.





ELSE





/*--------------------------------------------------------------------------*/


/* l-main.p */


IF qbf-s = 2 THEN


  ASSIGN


    /* each entry of 1 and also 2 must fit in format x(6) */


    qbf-lang[ 1] = '. :,     :,     :,     :,     :'


    qbf-lang[ 2] = ':'


    qbf-lang[ 3] = ' '


    qbf-lang[ 4] = '嘩 '


    qbf-lang[ 5] = ' 妬'


    /*cannot change length of 6 thru 17, right-justify 6-11,13-14 */


    qbf-lang[ 6] = '. :'


    qbf-lang[ 7] = '  橜 :'


    qbf-lang[ 8] = '  :'


    qbf-lang[ 9] = ' 騠:'


    qbf-lang[10] = '橫  .:'


    qbf-lang[11] = ' .妬:'


    qbf-lang[12] = '(.)'


    qbf-lang[13] = '壜 .'


    qbf-lang[14] = '     '


    qbf-lang[15] = '           ' /* 15..17 used as group.   */


    qbf-lang[16] = '         ' /*   do not change length, */


    qbf-lang[17] = ' ᫦: ' /*        but do right-justify  */


    qbf-lang[19] = ' ⮜ 驜  ⮦ ⫫. '


                 + '⢜  婜; '


    qbf-lang[20] = ' 篦   夘 ~{1~},  ⮜ 婜 ~{2~} '


                 + '    壜. ,    '


                 + ' ⩦  ,   . '


                 + '⢜  婜   ਫ਼; '


    qbf-lang[21] = ' ᨮ ⛠  壜   ਫ਼ !'


    qbf-lang[22] = '  暨 ਫ਼ ...'


    qbf-lang[23] = '"Compile"  暨 ਫ਼ ...'


    qbf-lang[24] = '⢜  ᣣ  㟞...'


    qbf-lang[25] = '礘     /ᛘ'


    qbf-lang[26] = '   - ~{1~} .'


    qbf-lang[27] = 'F. '


    qbf-lang[28] = 'A.  '


    qbf-lang[29] = '⢜  ⢜  棘 㫞  '


                 + '   暨; '


    qbf-lang[31] = 'ਫ਼ ਫ਼  婜'


    qbf-lang[32] = 'ਫ਼ 曦    '.





ELSE





/*--------------------------------------------------------------------------*/


/* l-main.p */


IF qbf-s = 3 THEN


  ASSIGN


    qbf-lang[ 1] = '''橦 ⢜ > 1 ⫫  ᫦,   ⧜ > 0'


    qbf-lang[ 2] = '  騠    ⮜  '


    qbf-lang[ 3] = '  篦 ⧜  夘 > 1'


    qbf-lang[ 4] = '⧜  ᨮ ᮠ  ⫫  ᫦'


    qbf-lang[ 5] = '⧜   ᮠ   '


    qbf-lang[ 6] = '  騠    ⮜  '


    qbf-lang[ 7] = ' 椫 橫   ⧜  夘 > 1'


    qbf-lang[ 8] = '槠  ᣣ    櫘 ᨮ  '


    qbf-lang[ 9] = '      ⮨  壜'


    qbf-lang[10] = '  篦  ⫫  '


    qbf-lang[11] = '橜 ⫫    ᫦'


    qbf-lang[12] = '橜     ៜ ⫫'


    qbf-lang[13] = '橘    ᡨ  ⫫ ⮨  髦 㨘'


    qbf-lang[14] = ' 橫    ᡨ 嘪 ⫫   ᢢ'.


/*--------------------------------------------------------------------------*/





RETURN.


