/*********************************************************************


* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *


* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *


* below.  All Rights Reserved.                                       *


*                                                                    *


* The Initial Developer of the Original Code is PSC.  The Original   *


* Code is Progress IDE code released to open source December 1, 2000.*


*                                                                    *


* The contents of this file are subject to the Possenet Public       *


* License Version 1.0 (the "License"); you may not use this file     *


* except in compliance with the License.  A copy of the License is   *


* available as of the date of this notice at                         *


* http://www.possenet.org/license.html                               *


*                                                                    *


* Software distributed under the License is distributed on an "AS IS"*


* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*


* should refer to the License for the specific language governing    *


* rights and limitations under the License.                          *


*                                                                    *


* Contributors:                                                      *


*                                                                    *


*********************************************************************/


/* t-r-eng.p - English language definitions for Reports module */





{ prores/t-define.i }





DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.





IF qbf-s < 0 THEN RETURN.


qbf-lang = "".





IF qbf-s = 1 THEN


  ASSIGN


/*r-header.p*/


    qbf-lang[ 1] = '    '


    qbf-lang[ 2] = '' /* must be < 8 characters */


                   /* 3..7 are format x(64) */


    qbf-lang[ 3] = '       '


                 + ''


    qbf-lang[ 4] = '~{COUNT~}         :  '


                 + '~{TIME~}   '


    qbf-lang[ 5] = '~{TODAY~}       :  '


                 + '~{NOW~}    '


    qbf-lang[ 6] = '~{PAGE~}  .   :  '


                 + '~{USER~}   '


    qbf-lang[ 7] = '~{VALUE <>~;<>~}   '


                 + ' ( [' + KBLABEL("GET") + '])'


    qbf-lang[ 8] = '   '


    qbf-lang[ 9] = ' [' + KBLABEL("GO") + '] , ['


                 + KBLABEL("GET") + ']  , ['


                 + KBLABEL("END-ERROR") + '] .'





/*r-total.p*/    /*"|---------------------------|"*/


    qbf-lang[12] = '   :'


                 /*"|--------------------------------------------|"*/


    qbf-lang[13] = '     :'


                 /*"|---| |---| |---| |---| |---|" */


    qbf-lang[14] = ' .    '


    qbf-lang[15] = ' '


    qbf-lang[16] = ' :'


    qbf-lang[17] = '   '





/*r-calc.p*/


    qbf-lang[18] = '    '


    qbf-lang[19] = '     '


    qbf-lang[20] = ' '


    qbf-lang[21] = '% '


    qbf-lang[22] = ',,,,'


    qbf-lang[23] = ''


    qbf-lang[24] = '      '


    qbf-lang[25] = '        '


    qbf-lang[26] = ''


    qbf-lang[27] = ''


                 /*"------------------------------|"*/


    qbf-lang[28] = '           ' /*right justify*/


    qbf-lang[29] = '      ' /*right justify*/


    qbf-lang[32] = '      .'.





ELSE





/*--------------------------------------------------------------------------*/


IF qbf-s = 2 THEN


  ASSIGN


/* r-space.p */  /*"------------------------------|  ---------|  |------"*/


    qbf-lang[ 1] = '                              '


    /* 2..8 must be less than 32 characters long */


    qbf-lang[ 2] = ' '


    qbf-lang[ 3] = '  '


    qbf-lang[ 4] = ' '


    qbf-lang[ 5] = '  '


    qbf-lang[ 6] = '  '


    qbf-lang[ 7] = '  ./'


    qbf-lang[ 8] = '  /.'


                  /*1234567890123456789012345678901*/


    qbf-lang[ 9] = ''


    qbf-lang[10] = '      (1)     '


    qbf-lang[11] = '   '


    qbf-lang[12] = '        1  '


    qbf-lang[13] = '        !'


    qbf-lang[14] = '          '





/*r-set.p*/        /* format x(30) for 15..22 */


    qbf-lang[15] = 'F.   /'


    qbf-lang[16] = 'P.   '


    qbf-lang[17] = 'T.   '


    qbf-lang[18] = 'S.  '


    qbf-lang[19] = 'LH.  '


    qbf-lang[20] = 'CH.  '


    qbf-lang[21] = 'RH.  '


    qbf-lang[22] = 'LF.  '


    qbf-lang[23] = 'CF.  '


    qbf-lang[24] = 'RF.  '


    qbf-lang[25] = 'FO.   .'


    qbf-lang[26] = 'LO.  . .'


    qbf-lang[32] = ' [' + KBLABEL("END-ERROR")


                 + ']    .'.





ELSE





/*--------------------------------------------------------------------------*/


IF qbf-s = 3 THEN


  ASSIGN


    /* r-main.p,s-page.p */


    qbf-lang[ 1] = '. :,     :,     :,     :,     :'


    qbf-lang[ 2] = ':'


    qbf-lang[ 3] = ' '


    qbf-lang[ 4] = ' '


    qbf-lang[ 5] = '' /* for <<more and more>> */


    qbf-lang[ 6] = ',' /* each word comma-separated */


    qbf-lang[ 7] = '<  >     & '


    qbf-lang[ 8] = '        '


                 + '255 '


    qbf-lang[ 9] = '     . '


                 + '  ; '


    qbf-lang[10] = ' ...'


    qbf-lang[11] = '"Compile"   ...'


    qbf-lang[12] = '    ...'


    qbf-lang[13] = '     /'


    qbf-lang[14] = '      '


                 + ''


    qbf-lang[15] = '     '


    qbf-lang[16] = ' ['


                 + (IF KBLABEL("CURSOR-UP") BEGINS "CTRL-" THEN 'CURSOR-UP'


                   ELSE KBLABEL("CURSOR-UP"))


                 + ']  ['


                 + (IF KBLABEL("CURSOR-DOWN") BEGINS "CTRL-" THEN 'CURSOR-DOWN'


                   ELSE KBLABEL("CURSOR-DOWN"))


                 + ']  , ['


                 + KBLABEL("END-ERROR") + ']  .'


    qbf-lang[17] = ''


    qbf-lang[18] = '~{1~}   .'


    qbf-lang[19] = '         '


                 + '  .'


    qbf-lang[20] = '       '


                 + ' .'


    qbf-lang[21] = ' '


    qbf-lang[23] = '       .'.





ELSE





/*--------------------------------------------------------------------------*/


/* FAST TRACK interface test for r-ft.p r-ftsub.p */


IF qbf-s = 4 THEN


  ASSIGN


    qbf-lang[ 1] = ' FAST TRACK         '


    qbf-lang[ 2] = '      .     PRINTER.'


    qbf-lang[ 3] = '  /...'


    qbf-lang[ 4] = '  ...'


    qbf-lang[ 5] = '   ...'


    qbf-lang[ 6] = '    WHERE...'


    qbf-lang[ 7] = '   ...'


    qbf-lang[ 8] = '   ...'


    qbf-lang[ 9] = '      ~{1~}  FAST TRACK. '


                 + '   ; '


    qbf-lang[10] = ' ...'


    qbf-lang[11] = '    FAST TRACK; '


    qbf-lang[12] = '  '


    qbf-lang[13] = ' FAST TRACK   TIME  /, '


                 + '  NOW.'


    qbf-lang[14] = ' FAST TRACK      ,   '


    qbf-lang[15] = ' FAST TRACK   ~{1~}  /, '


                 + '~{2~} .'


    qbf-lang[16] = '          '


                 + ' "_"'


    qbf-lang[17] = '   FAST TRACK:'


    qbf-lang[18] = '     FAST TRACK'


    qbf-lang[19] = '  FAST TRACK,  ...'


    qbf-lang[20] = '   /, '


                 + '   .'


    qbf-lang[21] = ' FAST TRACK   -/- .'


                 + '.'


    qbf-lang[22] = ':   ~{1~}    .'


    qbf-lang[23] = ''


    qbf-lang[24] = 'TOTAL,COUNT,MAX,MIN,AVG'


    qbf-lang[25] = ' FAST TRACK    .'


                 + 'H   .'


    qbf-lang[26] = '     FAST TRACK    '


                 + '  .'.








ELSE





/*--------------------------------------------------------------------------*/





IF qbf-s = 5 THEN


  ASSIGN


    /* r-short.p */


    qbf-lang[ 1] = '      '


                 + '.        "", '


                 + '            '


                 + ' .^   ,     '


                 + '      ~{1~} .^   '


                 + '       ; '


    qbf-lang[ 2] = ''


    qbf-lang[ 3] = ''


    qbf-lang[ 4] = '   " "   '


                 + '       .^^'


                 + ' ""       '


                 + ' ,         '


                 + '      .'


    qbf-lang[ 5] = '           '


                 + '.'


    qbf-lang[ 6] = '         '


                 + '.'


    qbf-lang[ 7] = '   ,     '


                 + '       ~{1~}'


                 + '.'


    qbf-lang[ 8] = '   - ,    '


                 + '         ~{1~}.'


    qbf-lang[ 9] = '     ,     '


                 + '    .'





    /* r-page.p */


    qbf-lang[26] = ' '


    qbf-lang[27] = "  "





    qbf-lang[28] = '     '


    qbf-lang[29] = ',     '


    qbf-lang[30] = '    .'


    qbf-lang[31] = '      '


    qbf-lang[32] = '     .'.





/*--------------------------------------------------------------------------*/





RETURN.


