/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* t-s-swe.p - Swedish language definitions for general system use */



{ prores/t-define.i }



DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.



IF qbf-s < 0 THEN RETURN.

qbf-lang = "".



/*--------------------------------------------------------------------------*/



/* l-edit.p,s-edit.p */

IF qbf-s = 1 THEN

  ASSIGN

    qbf-lang[ 1] = 'Infoga'

    qbf-lang[ 2] = 'Skert att du vill avsluta utan att spara ndringar?'

    qbf-lang[ 3] = 'Skriv namnet p fil som skall lsas in'

    qbf-lang[ 4] = 'Skriv skstrng'

    qbf-lang[ 5] = 'Vlj flt att infoga'

    qbf-lang[ 6] = 'Tryck [' + KBLABEL("GO") + '] fr spara, ['

                 + KBLABEL("GET") + '] fr addera flt, ['

                 + KBLABEL("END-ERROR") + '] fr ngra'

    qbf-lang[ 7] = 'Skstrng ej funnen.'.



ELSE



/*--------------------------------------------------------------------------*/



/* s-ask.p,s-where.p */

IF qbf-s = 2 THEN

  ASSIGN

    qbf-lang[ 1] = 'Lika med'

    qbf-lang[ 2] = 'Skilt frn'

    qbf-lang[ 3] = 'Mindre n'

    qbf-lang[ 4] = 'Mindre el lika'

    qbf-lang[ 5] = 'Strre n'

    qbf-lang[ 6] = 'Strre el lika'

    qbf-lang[ 7] = 'Brjar med'

    qbf-lang[ 8] = 'Innehller'    /* must match [r.4.23] */

    qbf-lang[ 9] = 'Matchar'



    qbf-lang[10] = 'Vlj ett flt'

    qbf-lang[11] = 'Uttryck'

    qbf-lang[12] = 'Ange ett vrde'

    qbf-lang[13] = 'Jmfrelser'



    qbf-lang[14] = 'Vid krning, be anvndare om ett vrde.'

    qbf-lang[15] = 'Ange frga som stlls vid krning:'



    qbf-lang[16] = 'Be om' /* data-type */

    qbf-lang[17] = 'vrde'



    qbf-lang[18] = 'Tryck [' + KBLABEL("END-ERROR") + '] fr avslut.'

    qbf-lang[19] = 'Tryck [' + KBLABEL("END-ERROR") + '] att ngra sista steg.'

    qbf-lang[20] = 'Press [' + KBLABEL("GET") + '] fr Expertlge.'



    qbf-lang[21] = 'Vlj jmfrelsetyp att utfras p fltet.'



    qbf-lang[22] = 'Ange ~{1~} vrde att jmfras med "~{2~}".'

    qbf-lang[23] = 'Ange ~{1~} vrde fr "~{2~}".'

    qbf-lang[24] = 'Tryck [' + KBLABEL("PUT")

                 + '] fr att fordra ett vrde vid krning.'

    qbf-lang[25] = 'Valtext: ~{1~} r ~{2~} ett ~{3~} vrde.'



    qbf-lang[27] = '"Expertlge" r inte det samma som "be om '

                 + 'ett vrde vid krning".  Anvnd det ena eller det andra.'

    qbf-lang[28] = 'Fr ej vara oknt vrde!'

    qbf-lang[29] = 'Ange flera vrden fr' /* '?' append to string */

    qbf-lang[30] = 'Ange flera urvalskriteriera?'

    qbf-lang[31] = 'Kombinera med fregende kriteria och anvnd?'

    qbf-lang[32] = 'Expertlge'.



ELSE



/*--------------------------------------------------------------------------*/

IF qbf-s = 3 THEN

  ASSIGN

/* s-info.p, s-format.p */

    qbf-lang[ 1] = 'Sort per'  /* s-info.p automatically right-justifies */

    qbf-lang[ 2] = 'och per'   /*   1..9 and adds colons for you. */

    qbf-lang[ 3] = 'Fil'      /* but must fit in format x(24) */

    qbf-lang[ 4] = 'Relation'

    qbf-lang[ 5] = 'Dr'

    qbf-lang[ 6] = 'Flt'

    qbf-lang[ 7] = 'Uttryck'

    qbf-lang[ 9] = 'Gmma rep. vrden?'



    qbf-lang[10] = 'FRN,PER,FR'

    qbf-lang[11] = 'Du har inte valt ngra tabeller!'

    qbf-lang[12] = 'Format och rubriker'

    qbf-lang[13] = 'Format'

    qbf-lang[14] = 'Vlj ett flt' /* also used by s-calc.p below */

    /* 15..18 must be format x(16) (see notes on 1..7) */

    qbf-lang[15] = 'Rubrik'

    qbf-lang[16] = 'Format'

    qbf-lang[17] = 'Databas'

    qbf-lang[18] = 'Typ'

    qbf-lang[19] = 'Anvnd tid vid sen. krning,minuter:sekunder'

    qbf-lang[20] = 'Uttryck kan ej vara oknt vrde (?)'



/*s-calc.p*/ /* there are many more for s-calc.p, see qbf-s = 5 thru 8 */

/*s-calc.p also uses #14 */

    qbf-lang[27] = 'Uttrycksbyggare'

    qbf-lang[28] = 'Uttryck'

    qbf-lang[29] = 'Ytterligare tillgg till detta uttryck?'

    qbf-lang[30] = 'Vlj operation'

    qbf-lang[31] = 'dagens datum'

    qbf-lang[32] = 'konstant vrde'.



ELSE



/*--------------------------------------------------------------------------*/



IF qbf-s = 4 THEN

  ASSIGN

/*s-help.p*/

    qbf-lang[ 1] = 'Ngon hjlp fr detta val finns nnu ej.'

    qbf-lang[ 2] = 'Hjlp'



/*s-order.p*/

    qbf-lang[15] = 'stigande/fallande' /*neither can be over 8 characters */

    qbf-lang[16] = 'Fr varje komponent, skriv "s" fr'

    qbf-lang[17] = 'stigande eller "f" fr fallande.'



/*s-define.p*/

    qbf-lang[21] = 'W. Bredd/Format av flt'

    qbf-lang[22] = 'F. Flt'

    qbf-lang[23] = 'A. Aktiva tabeller'

    qbf-lang[24] = 'T. Totaler och subtotaler'

    qbf-lang[25] = 'R. Ackumulerad total'

    qbf-lang[26] = 'P. Procent av total'

    qbf-lang[27] = 'C. Rknare'

    qbf-lang[28] = 'M. Matematikuttryck'

    qbf-lang[29] = 'S. Strnguttryck'

    qbf-lang[30] = 'N. Numeriska uttryck'

    qbf-lang[31] = 'D. Datumuttryck'

    qbf-lang[32] = 'L. Logiska uttryck'.



ELSE



/*--------------------------------------------------------------------------*/



/* s-calc.p - string expressions */

IF qbf-s = 5 THEN

  ASSIGN

    qbf-lang[ 1] = 's,konstant eller flt,s00=s24,~{1~}'

    qbf-lang[ 2] = 's,substrng,s00=s25n26n27,SUBSTRING(~{1~}'

                 + ';INTEGER(~{2~});INTEGER(~{3~}))'

    qbf-lang[ 3] = 's,kombinera tv strngar,s00=s28s29,~{1~} + ~{2~}'

    qbf-lang[ 4] = 's,kombinera tre strngar,s00=s28s29s29,'

                 + '~{1~} + ~{2~} + ~{3~}'

    qbf-lang[ 5] = 's,kombinera fyra strngar,s00=s28s29s29s29,'

                 + '~{1~} + ~{2~} + ~{3~} + ~{4~}'

    qbf-lang[ 6] = 's,Minst av tv strngar,s00=s30s31,MINIMUM(~{1~};~{2~})'

    qbf-lang[ 7] = 's,Strst av tv strngar,s00=s30s31,MAXIMUM(~{1~};~{2~})'

    qbf-lang[ 8] = 's,Lngd av strng,n00=s32,LENGTH(~{1~})'

    qbf-lang[ 9] = 's,Anv.id,s00=,USERID("RESULTSDB")'

    qbf-lang[10] = 's,Aktuell tid,s00=,STRING(TIME;"HH:MM:SS")'



    qbf-lang[24] = 'Ange fltnamnet att inkludera som en kolumn i din '

                 + 'rapport, el vlj  <<konstant vrde>> fr att infoga  '

                 + 'konstant strngvrde i rapporten.'

    qbf-lang[25] = 'SUBSTRING ger dig mjlighet att skriva en  del av en tecken'

                 + 'strng.  Vlj ett fltnamn.'

    qbf-lang[26] = 'Ange startpositionen i strngen.'

    qbf-lang[27] = 'Ange antal tecken du vill ta ut.'

    qbf-lang[28] = 'Vlj frsta vrdet'

    qbf-lang[29] = 'Vlj nsta vrde'

    qbf-lang[30] = 'Vlj frsta komponenten att jmfra'

    qbf-lang[31] = 'Vlj andra komponenten att jmfra'

    qbf-lang[32] = 'Returnerat tal motsvarar lngden av '

                 + 'vald strng.'.



ELSE



/*--------------------------------------------------------------------------*/



/* s-calc.p - numeric expressions */

IF qbf-s = 6 THEN

  ASSIGN

    qbf-lang[ 1] = 'n,Konstant el Flt,n00=n26,~{1~}'

    qbf-lang[ 2] = 'n,Minst av tv tal,n00=n24n25,MINIMUM(~{1~};~{2~})'

    qbf-lang[ 3] = 'n,Strst av tv tal,n00=n24n25,MAXIMUM(~{1~};~{2~})'

    qbf-lang[ 4] = 'n,Rest,n00=n31n32,~{1~} MODULO ~{2~}'

    qbf-lang[ 5] = 'n,Absolutvrde,n00=n27,'

                 + '(IF ~{1~} < 0 THEN - ~{1~} ELSE ~{1~})'

    qbf-lang[ 6] = 'n,Avrundat,n00=n28,ROUND(~{1~};0)'

    qbf-lang[ 7] = 'n,Avhugget,n00=n29,TRUNCATE(~{1~};0)'

    qbf-lang[ 8] = 'n,Kvadr.rot,n00=n30,SQRT(~{1~})'

    qbf-lang[ 9] = 'n,Visa som tid,s00=n23,STRING(INTEGER(~{1~});"HH:MM:SS")'



    qbf-lang[23] = 'Vlj ett flt att visa enligt HH:MM:SS'

    qbf-lang[24] = 'Vlj frsta komponent att jmfra'

    qbf-lang[25] = 'Vlj andra komponent att jmfra'

    qbf-lang[26] = 'Ange fltnamnet att inkludera som en kolumn i din '

                 + 'rapport, el vlj <<konst. vrde>> fr att infoga konstant '

                 + 'numeriskt vrde i rapporten.'

    qbf-lang[27] = 'Vlj ett flt som skall visas som ett absolutvrde '

                 + '(utan tecken).'

    qbf-lang[28] = 'Vlj ett flt som avrundas till nrmaste heltal.'

    qbf-lang[29] = 'Vlj ett flt som avrundas nedt (dec.delen '

                 + 'borttagen).'

    qbf-lang[30] = 'Vlj ett flt vars kvadr.rot berknas.'

    qbf-lang[31] = 'Efter division av ett tal (t) med ett annat (n) blir detta '

                 + 'resten.  Ange ett vrde p talet t.'

    qbf-lang[32] = 'Dividerat med talet n'.



ELSE



/*--------------------------------------------------------------------------*/



/* s-calc.p - date expressions */

IF qbf-s = 7 THEN

  ASSIGN

    qbf-lang[ 1] = 'd,Aktuellt datum,d00=,TODAY'

    qbf-lang[ 2] = 'd,Addera dagar till Datum,d00=d22n23,~{1~} + ~{2~}'

    qbf-lang[ 3] = 'd,Subtrahera dagar frn Datum,d00=d22n24,~{1~} - ~{2~}'

    qbf-lang[ 4] = 'd,Differens mellan tv datum,n00=d25d26,~{1~} - ~{2~}'

    qbf-lang[ 5] = 'd,Tidigaste av tv datum,d00=d20d21,MINIMUM(~{1~};~{2~})'

    qbf-lang[ 6] = 'd,Senaste av tv datum,d00=d20d21,MAXIMUM(~{1~};~{2~})'

    qbf-lang[ 7] = 'd,Dag i mnad,n00=d27,DAY(~{1~})'

    qbf-lang[ 8] = 'd,Mnad i r,n00=d28,MONTH(~{1~})'

    qbf-lang[ 9] = 'd,Mnadsnamn,s00=d29,ENTRY(MONTH(~{1~});"Januari'

                 + ';Februari;Mars;April;Maj;Juni;Juli;Augusti;September'

                 + ';Oktober;November;December")'

    qbf-lang[10] = 'd,rsvrde,n00=d30,YEAR(~{1~})'

    qbf-lang[11] = 'd,Veckodag,n00=d31,WEEKDAY(~{1~})'

    qbf-lang[12] = 'd,Namn p veckodag,s00=d32,ENTRY(WEEKDAY(~{1~});"'

                 + 'Sndag;Mndag;Tisdag;Onsdag;Torsdag;Fredag;Lrdag")'



    qbf-lang[20] = 'Vlj frsta komponent att jmfra'

    qbf-lang[21] = 'Vlj andra komponent att jmfra'

    qbf-lang[22] = 'Vlj ett datumflt.'

    qbf-lang[23] = 'Vlj ett flt som innehller antal dagar som skall '

                 + 'adderas till detta datum.'

    qbf-lang[24] = 'Vlj ett flt som innehller antal dagar som skall '

                 + 'subtraheras frn detta datum.'

    qbf-lang[25] = 'Jmfr tv datum och visa differensen mellan '

                 + 'dessa, i dagar, som en kolumn.  Vlj frsta '

                 + 'fltet.'

    qbf-lang[26] = 'Vlj nu andra datumfltet.'

    qbf-lang[27] = 'Detta returnerar dagen i mnaden som ett tal frn '

                 + '1 till 31.'

    qbf-lang[28] = 'Detta returnerar rets mnad som ett tal frn '

                 + '1 till 12.'

    qbf-lang[29] = 'Detta returnerar mnadens namn.'

    qbf-lang[30] = 'Detta returnerar rdelen av datum som ett heltal.'

    qbf-lang[31] = 'Detta returnerar veckodagsnumret, med sndag = 1.'

    qbf-lang[32] = 'Detta returnerar namnet p veckodagen.'.



ELSE



/*--------------------------------------------------------------------------*/



/* s-calc.p - mathematical expressions */

IF qbf-s = 8 THEN

  ASSIGN

    qbf-lang[ 1] = 'm,Addera,n00=n25n26m...,~{1~} + ~{2~}'

    qbf-lang[ 2] = 'm,Subtrahera,n00=n25n27m...,~{1~} - ~{2~}'

    qbf-lang[ 3] = 'm,Multiplicera,n00=n28n29m...,~{1~} * ~{2~}'

    qbf-lang[ 4] = 'm,Dividera,n00=n30n31m...,~{1~} / ~{2~}'

    qbf-lang[ 5] = 'm,Upphj till,n00=n25n32m...,EXP(~{1~};~{2~})'



    qbf-lang[25] = 'Ange frsta talet'

    qbf-lang[26] = 'Ange nsta tal att addera'

    qbf-lang[27] = 'Ange nsta tal att subtrahera'

    qbf-lang[28] = 'Ange frsta faktor'

    qbf-lang[29] = 'Ange nsta faktor'

    qbf-lang[30] = 'Ange tljare'

    qbf-lang[31] = 'Ange nmnare'

    qbf-lang[32] = 'Ange potens'.



/*--------------------------------------------------------------------------*/



RETURN.

