/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/* hmapmain.i - Main Code Block for HTML Mapping Procedures. 

    Bill Wood 5/96 */   



/* The CLOSE event can be used from inside or outside the procedure to  */

/* terminate it.                                                        */

ON CLOSE OF THIS-PROCEDURE 

   RUN dispatch ('destroy':U).



/* Now enable the interface and wait for the exit condition.            */

/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */

MAIN-BLOCK:

DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON STOP    UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  

  /* Load the HTM handles etc. */

  RUN dispatch IN THIS-PROCEDURE ('initialize':U).

 

  /* Process the current web event. */

  RUN dispatch IN THIS-PROCEDURE ('process-web-request':U).

END.



/* Run the local/adm-destroy procedures, if the procedure is ending.    */

IF NOT THIS-PROCEDURE:PERSISTENT THEN RUN dispatch ('destroy':U).   

