&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI

/* Procedure Description

"HTML Mapping Procedure Wizard



Use this wizard to create a new HTML Mapping procedure and associate form elements defined in a static HTML file with WebSpeed field objects, such as database or data object fields."

*/

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME CURRENT-WINDOW

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS w-html 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

/*------------------------------------------------------------------------



  File: 



  Description: 



  Input Parameters:

      <none>



  Output Parameters:

      <none>



  Author: 



  Created: 



------------------------------------------------------------------------*/

/*           This .W file was created with AppBuilder.                  */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Preprocessor Definitions ---                                         */



/* Parameters Definitions ---                                           */



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE Web-Object

&Scoped-define DB-AWARE no





/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */



/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */





/* ************************  Frame Definitions  *********************** */





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: Web-Object Template

   Allow: Query

   Frames: 1

   Add Fields to: Neither

   Editing: Special-Events-Only

   Events: web.output,web.input

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

/* DESIGN Window definition (used by the UIB) 

  CREATE WINDOW w-html ASSIGN

         HEIGHT             = 14.14

         WIDTH              = 60.6.

/* END WINDOW DEFINITION */

                                                                        */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB w-html 

/* *********************** Included-Libraries ************************* */



{src/web2/html-map.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME









/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW w-html

  VISIBLE,,RUN-PERSISTENT                                               */

/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME



 



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "HTML Wizard" w-html _INLINE

/* Actions: adm2/support/_wizard.w ? ? ? adm2/support/_wizdel.p */

/* HTML Mapping Wizard

Welcome to the HTML Mapping Wizard! The wizard will lead you through mapping HTML fields to database or DataObject fields. Press Next to proceed.

adm2/support/_wizntro.w,adm2/support/_wizhtml.w,adm2/support/_wizds.w,adm2/support/_wizmap.w,adm2/support/_wizend.w

*/

/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK w-html 





/* ************************  Main Code Block  ************************* */



/* Standard Main Block that runs adm-create-objects, initializeObject 

 * and process-web-request.

 * The bulk of the web processing is in the Procedure process-web-request

 * elsewhere in this Web object.

 */

{src/web2/template/hmapmain.i}



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wWin  _ADM-CREATE-OBJECTS

PROCEDURE adm-create-objects :

/*------------------------------------------------------------------------------

  Purpose:     Create handles for all SmartObjects used in this procedure.

               After SmartObjects are initialized, then SmartLinks are added.

  Parameters:  <none>

------------------------------------------------------------------------------*/



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE outputHeader w-html 

PROCEDURE outputHeader :

/*------------------------------------------------------------------------

  Purpose:     Output the MIME header, and any "cookie" information needed 

               by this procedure.  

  Parameters:  <none>

  Notes:       In the event that this Web object is state-aware, this is 

               a good place to set the WebState and WebTimeout attributes.

------------------------------------------------------------------------*/



  /* To make this a state-aware Web object, pass in the timeout period

   * (in minutes) before running outputContentType.  If you supply a 

   * timeout period greater than 0, the Web object becomes state-aware 

   * and the following happens:

   *

   *   - 4GL variables webState and webTimeout are set

   *   - a cookie is created for the broker to id the client on the return trip

   *   - a cookie is created to id the correct procedure on the return trip

   *

   * If you supply a timeout period less than 1, the following happens:

   *

   *   - 4GL variables webState and webTimeout are set to an empty string

   *   - a cookie is killed for the broker to id the client on the return trip

   *   - a cookie is killed to id the correct procedure on the return trip

   *

   * For example, set the timeout period to 5 minutes.

   *

   *   setWebState (5.0).

   */

    

  /* Output additional cookie information here before running outputContentType.

   *   For more information about the Netscape Cookie Specification, see

   *   http://home.netscape.com/newsref/std/cookie_spec.html  

   *   

   *   Name         - name of the cookie

   *   Value        - value of the cookie

   *   Expires date - Date to expire (optional). See TODAY function.

   *   Expires time - Time to expire (optional). See TIME function.

   *   Path         - Override default URL path (optional)

   *   Domain       - Override default domain (optional)

   *   Secure       - "secure" or unknown (optional)

   * 

   *   The following example sets custNum=23 and expires tomorrow at (about)

   *   the same time but only for secure (https) connections.

   *      

   *   RUN SetCookie IN web-utilities-hdl 

   *     ("custNum":U, "23":U, TODAY + 1, TIME, ?, ?, "secure":U).

   */ 

  output-content-type ("text/html":U).

  

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE process-web-request w-html 

PROCEDURE process-web-request :

/*------------------------------------------------------------------------

  Purpose:     Process the web request.

  Notes:       

------------------------------------------------------------------------*/

     

  /* STEP 0 -

   * Output the MIME header and set up the object as state-less or state-aware. 

   * This is required if any HTML is to be returned to the browser. 

   *

   * NOTE: Move 'RUN outputHeader.' to the GET section below if you are going

   * to simulate another Web request by running a Web Object from this

   * procedure.  Running outputHeader precludes setting any additional cookie

   * information.

   */ 

  RUN outputHeader.

  

  /* Describe whether to receive FORM input for all the fields.  For example,

   * check particular input fields (using GetField in web-utilities-hdl). 

   * Here we look at REQUEST_METHOD. 

   */

  IF REQUEST_METHOD = "POST":U THEN DO:

    /* STEP 1 -

     * Copy HTML input field values to the Progress form buffer. */

    RUN inputFields.

    

    /* STEP 2 -

     * Open the database or SDO query and and fetch the first record. */ 

    RUN findRecords.

    

    /* STEP 3 -    

     * AssignFields will save the data in the frame.

     * (it automatically upgrades the lock to exclusive while doing the update)

     * 

     *  If a new record needs to be created set AddMode to true before 

        running assignFields.  

     *     setAddMode(TRUE).   

     * RUN assignFields. */

    

    /* STEP 4 -

     * Decide what HTML to return to the user. Choose STEP 4.1 to simulate

     * another Web request -OR- STEP 4.2 to return the original form (the

     * default action).

     *

     * STEP 4.1 -

     * To simulate another Web request, change the REQUEST_METHOD to GET

     * and RUN the Web object here.  For example,

     *

     *  ASSIGN REQUEST_METHOD = "GET":U.

     *  RUN run-web-object IN web-utilities-hdl ("myobject.w":U).

     */

     

    /* STEP 4.2 -

     * To return the form again, set data values, display them, and output 

     * them to the WEB stream.  

     *

     * STEP 4.2a -

     * Set any values that need to be set, then display them. */

    RUN displayFields.

   

    /* STEP 4.2b -

     * Enable objects that should be enabled. */

    RUN enableFields.



    /* STEP 4.2c -

     * OUTPUT the Progress form buffer to the WEB stream. */

    RUN outputFields.

    

  END. /* Form has been submitted. */

 

  /* REQUEST-METHOD = GET */ 

  ELSE DO:

    /* This is the first time that the form has been called. Just return the

     * form.  Move 'RUN outputHeader.' here if you are going to simulate

     * another Web request. */ 

   

    /* STEP 1 -

     * Open the database or SDO query and and fetch the first record. */ 

    RUN findRecords.

    

    /* Return the form again. Set data values, display them, and output them

     * to the WEB stream.  

     *

     * STEP 2a -

     * Set any values that need to be set, then display them. */

    RUN displayFields.



    /* STEP 2b -

     * Enable objects that should be enabled. */

    RUN enableFields.



    /* STEP 2c -

     * OUTPUT the Progress from buffer to the WEB stream. */

    RUN outputFields.

  END. 

  

  /* Show error messages. */

  IF AnyMessage() THEN 

  DO:

     /* ShowDataMessage may return a Progress column name. This means you

      * can use the function as a parameter to HTMLSetFocus instead of 

      * calling it directly.  The first parameter is the form name.   

      *

      * HTMLSetFocus("document.DetailForm",ShowDataMessages()). */

     ShowDataMessages().

  END.

 

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



