&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI

&ANALYZE-RESUME

&Scoped-define WINDOW-NAME C-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 

/*********************************************************************

* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

**********************************************************************



  File: _probar.w



  Description: Displays a progress bar for Remote File Management       



  Input Parameters:

      p_filename  - Name of file to open, save, etc.

      p_brokerURL - Target WebSpeed broker URL

      p_value     - Percent of file action completed



  Output Parameters:

      <none>



  Author: D.M.Adams

  Created: 



------------------------------------------------------------------------*/

/*       This .W file was created with the Progress AppBuilder.         */

/*----------------------------------------------------------------------*/



/* Create an unnamed pool to store all the widgets created 

     by this procedure. This is a good default which assures

     that this procedure's triggers and internal procedures 

     will execute in this procedure's storage, and that proper

     cleanup will occur on deletion of the procedure. */



CREATE WIDGET-POOL.



/* ***************************  Definitions  ************************** */



/* Parameters Definitions ---                                           */

DEFINE INPUT PARAMETER p_fileName  AS CHARACTER NO-UNDO.

DEFINE INPUT PARAMETER p_brokerURL AS CHARACTER NO-UNDO.

DEFINE INPUT PARAMETER p_value     AS INTEGER   NO-UNDO.



/* Local Variable Definitions ---                                       */



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 



/* ********************  Preprocessor Definitions  ******************** */



&Scoped-define PROCEDURE-TYPE Window

&Scoped-define DB-AWARE no



/* Name of first Frame and/or Browse and/or first Query                 */

&Scoped-define FRAME-NAME DEFAULT-FRAME



/* Standard List Definitions                                            */

&Scoped-Define ENABLED-OBJECTS Btn_Cancel 

&Scoped-Define DISPLAYED-OBJECTS cfileName cBrokerURL cPercent 



/* Custom List Definitions                                              */

/* List-1,List-2,List-3,List-4,List-5,List-6                            */

                    

/* _UIB-PREPROCESSOR-BLOCK-END */

&ANALYZE-RESUME







/* ***********************  Control Definitions  ********************** */



/* Define the widget handle for the window                              */

DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.



/* Definitions of handles for OCX Containers                            */

DEFINE VARIABLE CtrlFrame AS WIDGET-HANDLE NO-UNDO.

DEFINE VARIABLE chCtrlFrame AS COMPONENT-HANDLE NO-UNDO.



/* Definitions of the field level widgets                               */

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 

     LABEL "Cancel" 

     SIZE 15 BY 1.



DEFINE VARIABLE cBrokerURL AS CHARACTER FORMAT "X(256)":U 

     VIEW-AS FILL-IN 

     SIZE 60 BY 1 NO-UNDO.



DEFINE VARIABLE cfileName AS CHARACTER FORMAT "X(256)":U 

     VIEW-AS FILL-IN 

     SIZE 60 BY 1 NO-UNDO.



DEFINE VARIABLE cPercent AS CHARACTER FORMAT "X(256)":U 

     VIEW-AS FILL-IN 

     SIZE 60 BY 1 NO-UNDO.





/* ************************  Frame Definitions  *********************** */



DEFINE FRAME DEFAULT-FRAME

     cfileName AT ROW 1.48 COL 4 NO-LABEL

     cBrokerURL AT ROW 2.43 COL 2 COLON-ALIGNED NO-LABEL

     cPercent AT ROW 3.86 COL 2 COLON-ALIGNED NO-LABEL

     Btn_Cancel AT ROW 4.81 COL 65

    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 

         SIDE-LABELS NO-UNDERLINE THREE-D 

         AT COL 1 ROW 1

         SIZE 81 BY 5.33.





/* *********************** Procedure Settings ************************ */



&ANALYZE-SUSPEND _PROCEDURE-SETTINGS

/* Settings for THIS-PROCEDURE

   Type: Window

   Allow: Basic,Window

   Add Fields to: Neither

   Other Settings: COMPILE

 */

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* *************************  Create Window  ************************** */



&ANALYZE-SUSPEND _CREATE-WINDOW

IF SESSION:DISPLAY-TYPE = "GUI":U THEN

  CREATE WINDOW C-Win ASSIGN

         HIDDEN             = YES

         TITLE              = "Saving..."

         HEIGHT             = 5.33

         WIDTH              = 81

         MAX-HEIGHT         = 7.48

         MAX-WIDTH          = 91.4

         VIRTUAL-HEIGHT     = 7.48

         VIRTUAL-WIDTH      = 91.4

         RESIZE             = no

         SCROLL-BARS        = no

         STATUS-AREA        = no

         BGCOLOR            = ?

         FGCOLOR            = ?

         KEEP-FRAME-Z-ORDER = yes

         THREE-D            = yes

         MESSAGE-AREA       = no

         SENSITIVE          = yes.

ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

/* END WINDOW DEFINITION                                                */

&ANALYZE-RESUME







/* ***********  Runtime Attributes and AppBuilder Settings  *********** */



&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES

/* SETTINGS FOR WINDOW C-Win

  NOT-VISIBLE,,RUN-PERSISTENT                                           */

/* SETTINGS FOR FRAME DEFAULT-FRAME

   NOT-VISIBLE                                                          */

ASSIGN 

       FRAME DEFAULT-FRAME:HIDDEN           = TRUE.



/* SETTINGS FOR FILL-IN cBrokerURL IN FRAME DEFAULT-FRAME

   NO-ENABLE                                                            */

/* SETTINGS FOR FILL-IN cfileName IN FRAME DEFAULT-FRAME

   NO-ENABLE ALIGN-L                                                    */

/* SETTINGS FOR FILL-IN cPercent IN FRAME DEFAULT-FRAME

   NO-ENABLE                                                            */

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)

THEN C-Win:HIDDEN = yes.



/* _RUN-TIME-ATTRIBUTES-END */

&ANALYZE-RESUME





/* Setting information for Queries and Browse Widgets fields            */



&ANALYZE-SUSPEND _QUERY-BLOCK FRAME DEFAULT-FRAME

/* Query rebuild information for FRAME DEFAULT-FRAME

     _Query            is NOT OPENED

*/  /* FRAME DEFAULT-FRAME */

&ANALYZE-RESUME



 





/* **********************  Create OCX Containers  ********************** */



&ANALYZE-SUSPEND _CREATE-DYNAMIC



&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN



/* OCX BINARY:FILENAME is: webutil\_probar.wrx */



CREATE CONTROL-FRAME CtrlFrame ASSIGN

       FRAME        = FRAME DEFAULT-FRAME:HANDLE

       ROW          = 4.81

       COLUMN       = 4

       HEIGHT       = .95

       WIDTH        = 60

       HIDDEN       = no

       SENSITIVE    = yes.

      CtrlFrame:NAME = "CtrlFrame":U .

/* CtrlFrame OCXINFO:CREATE-CONTROL from: {0713E8D2-850A-101B-AFC0-4210102A8DA7} type: ProgressBar */

      CtrlFrame:MOVE-AFTER(cPercent:HANDLE IN FRAME DEFAULT-FRAME).



&ENDIF



&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */





/* ************************  Control Triggers  ************************ */



&Scoped-define SELF-NAME C-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win

ON END-ERROR OF C-Win /* Saving... */

OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:

  /* This case occurs when the user presses the "Esc" key.

     In a persistently run window, just ignore this.  If we did not, the

     application would exit. */

  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win

ON WINDOW-CLOSE OF C-Win /* Saving... */

DO:

  /* This event will close the window and terminate the procedure.  */

  APPLY "CLOSE":U TO THIS-PROCEDURE.

  RETURN NO-APPLY.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&Scoped-define SELF-NAME Btn_Cancel

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel C-Win

ON CHOOSE OF Btn_Cancel IN FRAME DEFAULT-FRAME /* Cancel */

DO:

  RUN disable_UI.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





&UNDEFINE SELF-NAME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 





/* ***************************  Main Block  *************************** */



/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */

ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 

       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.



/* The CLOSE event can be used from inside or outside the procedure to  */

/* terminate it.                                                        */

ON CLOSE OF THIS-PROCEDURE 

   RUN disable_UI.



/* Best default for GUI applications is...                              */

PAUSE 0 BEFORE-HIDE.



/* Now enable the interface and wait for the exit condition.            */

/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */

MAIN-BLOCK:

DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK

   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  RUN enable_UI.



  ASSIGN

    cFileName:SCREEN-VALUE  = p_fileName

    cBrokerURL:SCREEN-VALUE = "to " + p_brokerURL

    {&WINDOW-NAME}:ROW      = MAXIMUM(1,(SESSION:HEIGHT - {&WINDOW-NAME}:HEIGHT) / 2)

    {&WINDOW-NAME}:COL      = MAXIMUM(1,(SESSION:WIDTH - {&WINDOW-NAME}:WIDTH) / 2)

    .

  VIEW FRAME DEFAULT-FRAME IN WINDOW C-Win.

  VIEW C-Win.

  APPLY "ENTRY":U TO {&WINDOW-NAME}.



  IF NOT THIS-PROCEDURE:PERSISTENT THEN

    WAIT-FOR CLOSE OF THIS-PROCEDURE.

END.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME





/* **********************  Internal Procedures  *********************** */



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load C-Win _CONTROL-LOAD

PROCEDURE control_load :

/*------------------------------------------------------------------------------

  Purpose:     Load the OCXs    

  Parameters:  <none>

  Notes:       Here we load, initialize and make visible the 

               OCXs in the interface.                        

------------------------------------------------------------------------------*/



&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.

DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.



OCXFile = SEARCH( "webutil\_probar.wrx":U ).

IF OCXFile = ? THEN

  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,

                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).



IF OCXFile <> ? THEN

DO:

  ASSIGN

    chCtrlFrame = CtrlFrame:COM-HANDLE

    UIB_S = chCtrlFrame:LoadControls( OCXFile, "CtrlFrame":U)

  .

  RUN initialize-controls IN THIS-PROCEDURE NO-ERROR.

END.

ELSE MESSAGE "webutil\_probar.wrx":U SKIP(1)

             "The binary control file could not be found. The controls cannot be loaded."

             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".



&ENDIF



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE

PROCEDURE disable_UI :

/*------------------------------------------------------------------------------

  Purpose:     DISABLE the User Interface

  Parameters:  <none>

  Notes:       Here we clean-up the user-interface by deleting

               dynamic widgets we have created and/or hide 

               frames.  This procedure is usually called when

               we are ready to "clean-up" after running.

------------------------------------------------------------------------------*/

  /* Delete the WINDOW we created */

  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)

  THEN DELETE WIDGET C-Win.

  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE

PROCEDURE enable_UI :

/*------------------------------------------------------------------------------

  Purpose:     ENABLE the User Interface

  Parameters:  <none>

  Notes:       Here we display/view/enable the widgets in the

               user-interface.  In addition, OPEN all queries

               associated with each FRAME and BROWSE.

               These statements here are based on the "Other 

               Settings" section of the widget Property Sheets.

------------------------------------------------------------------------------*/

  RUN control_load.

  DISPLAY cfileName cBrokerURL cPercent 

      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.

  ENABLE Btn_Cancel 

      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.

  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}

END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE set_scale C-Win 

PROCEDURE set_scale :

/*------------------------------------------------------------------------------

  Purpose:     

  Parameters:  <none>

  Notes:       

------------------------------------------------------------------------------*/

  DEFINE INPUT PARAMETER p_value AS INTEGER NO-UNDO.

  

  PROCESS EVENTS.

  ASSIGN

    cPercent:SCREEN-VALUE IN FRAME {&FRAME-NAME} = STRING(p_value) + 

                                                   " percent"

    chCtrlFrame:ProgressBar:Value                = p_value.



END PROCEDURE.



/* _UIB-CODE-BLOCK-END */

&ANALYZE-RESUME



